/*ͻ
     Nom du fichier : BIBLIOWM.C                                          
  ͹
     Fonction       : Module de la bibliothque WMLIB.OBJ                 
                                                                          
                                                                          
  Ķ
     Auteur         : William MARIE                                       
     Dvelopp le   : 12/10/91                                            
     Dernire modif.: 25/02/92                                            
  Ķ
     Compilation    :                                                     
                                                                          
  ͼ*/


#include <dir.h>
#include <alloc.h>
#include <stdlib.h>
#include "wmlib.h"     /* dfinitions et prototypes externes */
#include "wmansi.h"
#include "wmmouse.h"
#include "wmwind.h"



  /********************* variable globale du module *********************/
static boolean insertion = FALSE;
const char *nom_jour[] = { "", "Lun", "Mar", "Mer", "Jeu", "Ven", "Sam", "Dim" };
boolean cursorsaved = FALSE;
byte    cur1, cur2;
byte maxdrive;
byte mousebuttons;
struct text_info info_text;
word    videoseg = 0;
byte    videocard;
boolean colorcard;
char    *video_device[] =
{
  "Pas de carte video",
  "MDA/Hercules avec cran monochrome",
  "CGA avec moniteur CGA",
  "",
  "EGA avec moniteur EGA ou Multisync",
  "EGA avec moniteur monochrome",
  "",
  "VGA avec moniteur monochrome analogique",
  "VGA avec moniteur couleur analogique"
};
  /* fentre par defaut = cran  l'allumage */
static struct windowdef defaultwind =  
{
  OPEN, 1, 1, 80, 25, FALSE, FALSE, Attr(LIGHTGRAY,BLACK), 0, 0, 0, 0,
  NULL, NULL
};
  /* fentre active = defaut */
static struct windowdef *activewind = &defaultwind;  


   
  /************************ prototypes internes *************************/

void cup(byte x, byte y);
int ANSI_SGR(int couleur_texte, int couleur_fond);
unsigned long conv2int(unsigned __fort, unsigned __faible);
char *convbin16(unsigned int nombre);
int ctrldate(char *chaine_date, word *jour, word *mois, word *annee);
static int calcul(int c_A2, int c_mois, int c_jour, int c_N);
static boolean test_validite(int jour, int mois, int N);
void readcursor(void);
void hidecursor(void);
void showcursor(void);
void squarecursor(void);
void dputch(byte __x, byte __y, byte __coultext, char __car);
void dputs(byte __x, byte __y, byte __coultext, char *__str);
void drelin(void);
struct ftime dtimetoftime(struct dtime *ptr_dtime);
unsigned long dtimetolft(struct dtime *_dt);
void errexit(byte _i);
void frame(byte __X1, byte __Y1, byte __X2, byte __Y2, byte __type_cadre,
  byte __coul_car, byte __coul_fond, boolean __ombrage, boolean __efface);
void freelstchar(int total, char **liste);
void freelstffblk(int total, struct ffblk **liste);
void freelstsdrive(byte total, sdrive **liste);
struct dtime ftimetodtime(struct ftime *ptr_ftime);
struct dtime getdtimesys(void);
void *getmem(int size);
char *getstr( byte x, byte y, word LongTotale, word LongSaisie,
  byte SaisieAttr, byte CoulTxt, byte CoulFond, char *EntreeChaine,
  byte *carclav, byte *codclav );
void repchar(byte n, char c);
static void debut(byte fin_tableau, byte LongSaisie, byte x, byte y,
  byte *pos_tableau, char tableau[81]);
static void gauche(byte fin_tableau, byte LongSaisie, byte x, byte y,
  byte *pos_tableau, char tableau[81], byte LongTotale);
static void droite(byte fin_tableau, byte LongSaisie, byte x, byte y,
  byte *pos_tableau, char tableau[81], byte LongTotale);
static void fin(byte fin_tableau, byte LongSaisie, byte x, byte y,
  byte *pos_tableau, char tableau[81]);
static void marche_arriere(byte *fin_tableau, byte LongSaisie, byte x, byte y,
  byte *pos_tableau, char tableau[81], byte LongTotale);
static void suppression(byte *fin_tableau, byte LongSaisie, byte x, byte y,
  byte pos_tableau, char tableau[81]);
static void saisie(byte *fin_tableau, byte LongSaisie, byte x, byte y,
  byte *pos_tableau, char tableau[81], byte LongTotale, byte carclav,
  byte SaisieAttr);
char *getstrdatesys(void);
char *getstrtimesys(void);
struct ffblk **mklstffblk(char *masque, char attribut, int *nombre,
  int tri);
static struct ffblk **shell_ffblk_ff_name(struct ffblk **base, int final);
static struct ffblk **shell_ffblk_ff_fdate(struct ffblk **base, int final);
static struct ffblk **shell_ffblk_ff_fsize_d(struct ffblk **base, int final);
static struct ffblk **shell_ffblk_ff_fsize_c(struct ffblk **base, int final);
static int compare( const char *a, const char *b);
char **mklstfile(char *masque, char attribut, int *nombre);
static char **shell(char **base, int final);
sdrive **mklstsdrive(void);
void mousearea(word x1, word y1, word x2, word y2);
void mousecurtxt(boolean curelec, word masqueAND, word masqueXOR);
void mousegotoxy(word pos_x, word pos_y);
void mousehide(void);
boolean mouseinstalled(void);
void mouseshow(void);
s_mouse mousestatus(void);
t_mouse mousetype(void);
  void printcenter(char *text, byte line, byte color);
int round(int a, int b);
long lround(long int a, long int b);
static void affiche_cadre_blanc(byte sel_x, byte sel_y);
static void efface_cadre_blanc(byte sel_x, byte sel_y, byte l_coultext);
void selectcolor(int x, int y, byte *coultext, byte *coulfond);
char *strdtime(struct dtime *_dt);
unsigned char toupperfr (unsigned char c);
void wmlibinit(void);
struct windowdef *openwindow(int x1, int y1, int x2, int y2, int bordertype,
  int bordercolor, int windowcolor, boolean shadow, const char *banner);
static boolean swapwindow(struct windowdef *w);
boolean hidewindow(struct windowdef *w);
boolean showwindow(struct windowdef *w);
boolean movewindow(struct windowdef *w, int x, int y);
boolean closewindow(struct windowdef *w);




/*man=====================================================================
  cup()    fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Squence ANSI. Positionne le curseur sur l'cran
  SYNTAXE:
    #include <wmansi.h>
    void cup(byte x, byte y>
  PROTOTYPE DANS:
    wmansi.h
  DESCRIPTION:
    Strictement quivalent au gotoxy() de la bibliothque standard conio.h,
    mais en utilisant la squence ANSI. 
  VALEUR(S) PASSEE(S):
    Position x et y de type byte.
  VALEUR RETOURNEE:
    Aucune
  CONTROLE:
    Aucun. Les valeurs doivent pouvoir correspondre aux coordonnes de
    l'cran texte sinon elles sont ignores et l'affichage se fait  la
    position courante x et/ou y.
  VOIR AUSSI:

  PROGRAMME EXEMPLE:
    EXANSI.C
  ========================================================================*/
void cup(byte x, byte y)
{
  char str_x[3];
  char str_y[3];
  itoa(x, str_x, 10);
  itoa(y, str_y, 10);
  printf("\x1B[%s;%sH", str_y, str_x);
}

/*man=====================================================================
  ANSI_SGR()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Squense ANSI. Change les attributs video
  SYNTAXE:
    #include <wmansi.h>
    int ANSI_SGR(int couleur_texte, int couleur_fond)
  PROTOTYPE DANS:
    wmansi.h
  DESCRIPTION:
    Change durablement les attributs video en mode texte y compris pour
    les fonctions d'affichage et de saisie qui ne se sentent pas concerns
    par les fonctions standards de modification de couleurs.
  VALEUR(S) PASSEE(S):
    2 valeurs de type int: couleur de texte et couleur de fond pouvant tre
    prises dans les valeurs enum standard.
  VALEUR RETOURNEE:
    -1 en cas de mauvais paramtres 0 si tout est correct.
  CONTROLE:
    Teste la validit des paramtres.
  VOIR AUSSI:

  PROGRAMME EXEMPLE:
    TESTANSI.C
  ========================================================================*/
int ANSI_SGR(int couleur_texte, int couleur_fond)
{
  char str_couleur_texte[4];
  char str_couleur_fond[4];
  char intensite;

  switch (couleur_texte)
  {
    case BLACK        : strcpy(str_couleur_texte, "30"); intensite = '0'; break;
    case BLUE         : strcpy(str_couleur_texte, "34"); intensite = '0'; break;
    case GREEN        : strcpy(str_couleur_texte, "32"); intensite = '0'; break;
    case CYAN         : strcpy(str_couleur_texte, "36"); intensite = '0'; break;
    case RED          : strcpy(str_couleur_texte, "31"); intensite = '0'; break;
    case MAGENTA      : strcpy(str_couleur_texte, "35"); intensite = '0'; break;
    case BROWN        : strcpy(str_couleur_texte, "33"); intensite = '0'; break;
    case LIGHTGRAY    : strcpy(str_couleur_texte, "37"); intensite = '0'; break;
    case DARKGRAY     : strcpy(str_couleur_texte, "30"); intensite = '1'; break;
    case LIGHTBLUE    : strcpy(str_couleur_texte, "34"); intensite = '1'; break;
    case LIGHTGREEN   : strcpy(str_couleur_texte, "32"); intensite = '1'; break;
    case LIGHTCYAN    : strcpy(str_couleur_texte, "36"); intensite = '1'; break;
    case LIGHTRED     : strcpy(str_couleur_texte, "31"); intensite = '1'; break;
    case LIGHTMAGENTA : strcpy(str_couleur_texte, "35"); intensite = '1'; break;
    case YELLOW       : strcpy(str_couleur_texte, "33"); intensite = '1'; break;
    case WHITE        : strcpy(str_couleur_texte, "37"); intensite = '1'; break;
    default           : return -1;
  }
  switch (couleur_fond)
  {
    case BLACK     : strcpy(str_couleur_fond, "40"); break;
    case BLUE      : strcpy(str_couleur_fond, "44"); break;
    case GREEN     : strcpy(str_couleur_fond, "42"); break;
    case CYAN      : strcpy(str_couleur_fond, "46"); break;
    case RED       : strcpy(str_couleur_fond, "41"); break;
    case MAGENTA   : strcpy(str_couleur_fond, "45"); break;
    case BROWN     : strcpy(str_couleur_fond, "43"); break;
    case LIGHTGRAY : strcpy(str_couleur_fond, "47"); break;
    default        : return -1;
  }
  printf("\x1B[%c;%s;%sm", intensite, str_couleur_texte, str_couleur_fond);
  return 0;
}

/*man=====================================================================
  conv2int()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Transforme 2 entiers non signs en un entier long non sign
  SYNTAXE:
    #include <wmlib.h>
    unsigned long conv2int(unsigned __fort, unsigned __faible)
  PROTOTYPE DANS
    wmlib.h
  DESCRIPTION:
    Fonction d'usage gnral o il est ncessaire de rassembler 2 entiers
    non signs, l'un de poids fort, l'autre de poids faible, pour confectionner
    un entier long non sign.
    En particulier les 2 entiers date et temps issus de la structure ffblk:
    ff_fdate et ff_fdate sont transforms un entier long non sign ce qui
    permet d'avoir une donne date-temps facile  manipuler pour des
    comparaisons ou des tris.
  VALEUR(S) PASSEE(S):
    2 entiers date et temps compacts
  VALEUR RETOURNEE:
    1 entier long
  CONTROLE:
    Aucun
  VOIR AUSSI
    findfirst() pour la dfinition de la structure ffblk
  PROGRAMME EXEMPLE:

  ========================================================================*/
unsigned long conv2int(unsigned __fort, unsigned __faible)
{
  return( ((long)__fort << 16) + __faible);
}

/*man=====================================================================
  convbin16()    fonction utilisateur
  ------------------------------------------------------------------------
  EFFET:
    Conversion d'un entier non sign en binaire
  SYNTAXE:
    #include <wmlib.h>
    char *convbin16(unsigned int nombre)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Conversion d'un entier non sign en un nombre binaire sous forme
    d'une chane binaire de 16 caractres.
  VALEUR(S) PASSEE(S):
    Le nombre
  VALEUR RETOURNEE:
    La chane (variable static)
  CONTROLE:
    Aucun
  VOIR AUSSI:

  PROGRAMME EXEMPLE:
    EXCONVBI.C
  ========================================================================*/
char *convbin16(unsigned int nombre)
{
  int i;
  static char bin[16];
  unsigned int valeur;

  for(i = 15, valeur = 1; i >= 0; i--, valeur = valeur << 1) 
    if((nombre & valeur) == valeur)
      bin[i] = '1';
    else
      bin[i] = '0';
  bin[16] = 0;
  return bin;
}

/*man=====================================================================
  ctrldate()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Contrle la validit d'une date, retourne le numro de jour.
  SYNTAXE:
    #include <wmlib.h>
    int ctrldate(char *chaine_date, word *jour, word *mois, word *annee)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Cette fonction contrle la validit d'une date et retourne le numro
    du jour et 3 pointeurs passs de type word (unsigned int) sur le jour,
    le mois et la date.
  VALEUR(S) PASSEE(S):
    Reoit un pointeur sur une chane date. La chane doit tre de la forme
    JJ/MM/AAAA et 3 variables pointeur de type word.
  VALEUR RETOURNEE:
    Le numro du jour de type int dans l'intervalle (Lundi=1 jusqu'
    Dimanche = 7). Retourne -1 en cas d'erreur.
  CONTROLE:
    La forme de la chane est contrle, la validit des constituants JJ, MM,
    AAAA est contrle. L'intervalle anne (fix arbitrairement entre 1900
    et 2500) est contrl.
  VOIR AUSSI:
    variable globale nom_jour[]
  PROGRAMME EXEMPLE:
    EXDTEMPS.C
  ========================================================================*/
int ctrldate(char *chaine_date, word *jour, word *mois, word *annee)
{
  int A1, A2;
  int N, NumJour;
  double R;
  char transfert[5];

    /* test de la longueur de la chaine attendue */
  if (strlen(chaine_date) != 10) return -1;

    /* test de la prsence des sparateurs '/' au bon endroit */
  if ( (chaine_date[2] != '/') || (chaine_date[5] != '/') ) return -1;

    /* test de la conversion numrique des jours */
  transfert[0] = chaine_date[0];
  transfert[1] = chaine_date[1];
  transfert[2] = '\0';
  *jour = atoi(transfert);
  if (*jour <= 0) return -1;

    /* test de la conversion numrique des mois */
  transfert[0] = chaine_date[3];
  transfert[1] = chaine_date[4];
  transfert[2] = '\0';
  *mois = atoi(transfert);
  if (*mois <= 0) return -1;

    /* test de la conversion numrique des annees */
  transfert[0] = chaine_date[6];
  transfert[1] = chaine_date[7];
  transfert[2] = chaine_date[8];
  transfert[3] = chaine_date[9];
  transfert[4] = '\0';
  *annee = atoi(transfert);
  if (*annee <= 0) return -1;

    /* limitation des annes */
  if ((*annee < 1900) || (*annee > 2500)) return -1;

    /* rcupration milliers et centaines d'annnes dans A1 */
  transfert[0] = chaine_date[6];
  transfert[1] = chaine_date[7];
  transfert[2] = '\0';
  A1 = atoi(transfert);

    /* rcupration dizaines et units d'annes dans A2 */
  transfert[0] = chaine_date[8];
  transfert[1] = chaine_date[9];
  transfert[2] = '\0';
  A2 = atoi(transfert);

    /* Calcul du jour de la semaine */
  if (*mois > 2)
  {
    N = 0;
    if ((NumJour = calcul(A2, *mois, *jour, N)) == -1)  return -1;
    else return NumJour;
  }
  N = 2;
  if (A2 == 0)
  {
    R = A1 - 4 * (int)(A1 / 4);
    if (R == 0)
    {
      N = 1;
      if ((NumJour = calcul(A2, *mois, *jour, N)) == -1)  return -1;
      else return NumJour;
    }
    else
    {
      if ((NumJour = calcul(A2, *mois, *jour, N)) == -1)  return -1;
      else return NumJour;
    }
  }
  R = A2 - 4 * (int)(A2 / 4);
  if (R != 0)
  {
    if ((NumJour = calcul(A2, *mois, *jour, N)) == -1)  return -1;
    else return NumJour;
  }
  N = 1;
  if ((NumJour = calcul(A2, *mois, *jour, N)) == -1)  return -1;
  else return NumJour;
}

/*========================================================================
  calcul()  fonction prive de ctrldate()
  ------------------------------------------------------------------------
  Fonction interne au module.
  Calcule le jour de la semaine en fonction des paramtres: partie dizaine
  et unit d'anne, mois, jour et indicateur de bisextilit.
  Teste la validit des jours
  retourne le jour de la semaine et -1 en cas d'erreur
  ========================================================================*/
static int calcul(int c_A2, int c_mois, int c_jour, int c_N)
{
  double C;
  int c_NumJour;

  C = (long int)(365.25 * c_A2) + (int)(30.56 * c_mois) + c_N + c_jour;
  c_NumJour = (int)(3 + C - 7 * (int)((C + 2) / 7));
  if (test_validite(c_jour, c_mois, c_N)) return c_NumJour;
  else return -1;
}

/*========================================================================
  test_validit()  fonction prive de ctrldate()
  ------------------------------------------------------------------------
  Fonction interne au module.
  Teste la validit de jour en fonction de mois et de l'indicateur de
  bisextilit. Retourne FALSE ou TRUE selon le rsultat
  ========================================================================*/
static boolean test_validite(int jour, int mois, int N)
{
  switch (mois)
  {
    case  1 : if (jour > 31) return FALSE; break;
    case  2 : if ( (jour > 28) && (N != 1) ) return FALSE;
              else if ( (jour > 29) && (N == 1) ) return FALSE;
    case  3 : if (jour > 31) return FALSE; break;
    case  4 : if (jour > 30) return FALSE; break;
    case  5 : if (jour > 31) return FALSE; break;
    case  6 : if (jour > 30) return FALSE; break;
    case  7 : if (jour > 31) return FALSE; break;
    case  8 : if (jour > 31) return FALSE; break;
    case  9 : if (jour > 30) return FALSE; break;
    case 10 : if (jour > 31) return FALSE; break;
    case 11 : if (jour > 30) return FALSE; break;
    case 12 : if (jour > 31) return FALSE; break;
    default : return FALSE;
  }
  return TRUE;
}

/*man=====================================================================
  readcursor()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Lecture de la forme du curseur
  SYNTAXE:
    #include <wmlib.h>
    void readcursor(void)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Cette fonction sert, gnralement au dbut d'un programme,  sauvegarder
    la forme d'origine du curseur dans les deux variables globales de type
    byte cur1 et cur2. En fait cette fonction a peu de raison d'tre appele
    si on utilise les fonctions hidecursor() et squarecursor() qui se
    chargent de cette basse besogne. L'indicateur boolen cursorsaved,
    prinitialis  false passe  true. Toutefois il est possible d'appeler
    cette fonction plusieurs fois, cursorsaved ne l'interdit pas.
    A l'utilisateur de grer cet appel.
  VALEUR(S) PASSEE(S):
    Aucune
  VALEUR RETOURNEE:
    Aucune
  CONTROLE:
    Aucun
  VOIR AUSSI:
    hidecursor(), showcursor(), squarecursor
  PROGRAMME EXEMPLE:
    EXCURSOR.C
  ========================================================================*/
void readcursor(void)
{
  union REGS inregs, outregs;

  inregs.h.ah = 3;
  int86(0x10, &inregs, &outregs);
  cur1 = outregs.h.ch;
  cur2 = outregs.h.cl;
  cursorsaved = TRUE;
}

/*man=====================================================================
  hidecursor()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Supprime le curseur
  SYNTAXE:
    #include <wmlib.h>
    void hidecursor(void)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Supprime le curseur quelque soit le mode video (texte). Si cela n'a t
    fait (la variable globale booolenne cursorsaved tant  sa valeur de
    prinitialisation false) il y a un appel  readcursor() afin de
    sauvegarder le curseur avant de le supprimer.
  VALEUR(S) PASSEE(S):
    Aucune
  VALEUR RETOURNEE:
    Aucune
  CONTROLE:
    Aucun
  VOIR AUSSI:
    readcursor(), showcursor(), squarecursor()
  PROGRAMME EXEMPLE:
    EXCURSOR.C
  ========================================================================*/
void hidecursor(void)
{
  union REGS inregs, outregs;

  if (cursorsaved == FALSE) readcursor(); /* si ce n'a pas t fait,
                                            sauvegarde du curseur */
  inregs.h.ah = 1;
  inregs.h.ch = 0xFF;     /* valeur provoquant la disparition du curseur */
  inregs.h.cl = 0xFF;     /* quelque soit le mode video                  */
  int86(0x10, &inregs, &outregs);
}

/*man=====================================================================
  showcursor()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Restitue le curseur
  SYNTAXE:
    #include <wmlib.h>
    void showcursor(void)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Restitue le curseur tel qu'il a t sauvegard dans les variables
    globales cur1 et cur2
  VALEUR(S) PASSEE(S):
    Aucune
  VALEUR RETOURNEE:
    Aucune
  CONTROLE:
    Vrifie que la variable globale boolenne cursorsaved est true (qu'il y a
    une valeur de curseur sauvegarde dans cur1 et cur2) pour xcuter le
    corps de la fonction.
  VOIR AUSSI:
    hidecursor()
  PROGRAMME EXEMPLE:
    EXCURSOR.C
  ========================================================================*/
void showcursor(void)
{
  union REGS inregs, outregs;

  if (cursorsaved)
  {
    inregs.h.ah = 1;
    inregs.h.ch = cur1;
    inregs.h.cl = cur2;
    int86(0x10, &inregs, &outregs);
  }
}

/*man=====================================================================
  squarecursor()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Met le curseur en carr plein
  SYNTAXE:
    #include <wmlib.h>
    void squarecursor(void)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Le curseur texte prend la forme d'un carr pour montrer, par exemple,
    le passage en mode insertion.
  VALEUR(S) PASSEE(S):
    Aucune
  VALEUR RETOURNEE:
    Aucune
  CONTROLE:
    La fonction vrifie que le curseur avant l'appel a dja t sauvegard
    dans les variables globales cur1 et cur2 en testant la variable boolenne
    cursorsaved.
  VOIR AUSSI:
    readcursor(), hidecursor(), showcursor()
  PROGRAMME EXEMPLE:
    EXCURSOR.C
  ========================================================================*/
void squarecursor(void)
{
  union REGS inregs, outregs;

  if (cursorsaved == FALSE) readcursor(); /* si ce n'a pas t fait,
                                            sauvegarde du curseur */
  inregs.h.ah = 1;
  if (videocard == 0xFF)
    errexit(2);
  else
  {
    if (info_text.currmode == 7)
    {
      inregs.h.ch =  6;
      inregs.h.cl = 12;
    }
    else
    {
      inregs.h.ch = 4;
      inregs.h.cl = 7;
    }
    int86(0x10, &inregs, &outregs);
  }
}

/*man=====================================================================
  dputch()    fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Affiche un caractre avec une couleur sans changer la couleur du fond
    rencontre.
  SYNTAXE:
    #include <wmlib.h>
    void dputch(byte __x, byte __y, byte __coultext, __char car)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Permet d'afficher  un endroit quelconque de l'cran (en mode texte)
    un caractre d'une couleur quelconque sans modifier la couleur du fond
    d'origine.
  VALEUR(S) PASSEE(S):
    Position X et Y de type byte, couleur de texte de type byte et caractre
    de type char
  VALEUR RETOURNEE:
    Aucune
  CONTROLE:
    Aucun contrle. L'appelant doit vrifier le domaine de validit des
    paramtres.
  VOIR AUSSI:
    dputs()
  PROGRAMME EXEMPLE:
    EXDPUT.C
  ========================================================================*/
void dputch(byte __x, byte __y, byte __coultext, char __car)
{
  byte attribut;
  unsigned char ucar;

  ucar = __car;              /* ncessit d'avoir un unsigned char pour poke */
  attribut = peekb(videoseg, (160 * (__y - 1)) + (__x - 1) * 2 + 1);
  attribut = attribut >> 4;
  attribut = (attribut << 4) + __coultext;
  poke(videoseg, (160 * (__y - 1)) + (__x - 1) * 2, (attribut << 8) + ucar);
}

/*man=====================================================================
  dputs()    fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Affiche une chane de caractres avec une couleur sans changer la
    couleur du fond rencontre.
  SYNTAXE:
    #include <wmlib.h>
    void dputs(byte __x, byte __y, byte __coultext, char *__str)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Permet d'afficher  un endroit quelconque de l'cran (en mode texte)
    une chane de caractres d'une couleur quelconque sans modifier la
    couleur du fond d'origine.
  VALEUR(S) PASSEE(S):
    Position X et Y de type byte, couleur de texte de type byte et pointeur
    sur la chane de caractres de type char
  VALEUR RETOURNEE:
    Aucune
  CONTROLE:
    Aucun contrle. L'appelant doit vrifier le domaine de validit des
    paramtres.
  VOIR AUSSI:
    dputch()
  PROGRAMME EXEMPLE:
    EXDPUT.C   
  ========================================================================*/
void dputs(byte __x, byte __y, byte __coultext, char *__str)
{
  byte i;

  for (i=0; i <= strlen (__str); i++)
    dputch (__x+i, __y, __coultext, __str[i]);
}

/*man=====================================================================
  drelin()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Fait drelin
  SYNTAXE:
    #include <wmlib.h>
    void drelin(void)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Emet un son modul (pour changer du '\x07')
  VALEUR(S) PASSEE(S):
    Aucune
  VALEUR RETOURNEE:
    Aucune
  CONTROLE:
    Aucun
  VOIR AUSSI:

  PROGRAMME EXEMPLE:

  ========================================================================*/
void drelin(void)
{
  byte i;

  for (i = 1; i <= 3; i++)
  {
    sound(800);
    delay(100);
    sound(600);
    delay(100);
  }
  nosound();
}

/*man=====================================================================
  dtimetoftime()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    conversion de structures dtime en ftime.
  SYNTAXE:
    #include <wmlib.h>
    struct ftime *dtimetoftime(struct dtime *ptr_dtime)
  PROTOTYPE DANS
    wmlib.h
  DESCRIPTION:
    Convertit une structure dtime (W.M.) en structure ftime (Borland)
  VALEUR(S) PASSEE(S):
    Un pointeur sur la structure dtime.
  VALEUR RETOURNEE:
    Un pointeur sur la structure ftime.
  CONTROLE:
    Retourne NULL si la structure dtime est NULL, pour le reste l'appelant
    doit s'assurer de la valeur des membres de la structure dtime.
  VOIR AUSSI
    ftimetodtime()
  PROGRAMME EXEMPLE:
    EXDTEMPS.C
  ========================================================================*/
struct ftime dtimetoftime(struct dtime *ptr_dtime)
{
  struct ftime pft;

  pft.ft_year  = ptr_dtime->dt_annee - 1980;
  pft.ft_month = ptr_dtime->dt_mois;
  pft.ft_day   = ptr_dtime->dt_jour;
  pft.ft_hour  = ptr_dtime->dt_heure;
  pft.ft_min   = ptr_dtime->dt_minute;
  pft.ft_tsec  = ptr_dtime->dt_seconde / 2;
  return pft;
}
/*man=====================================================================
  dtimetolft()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Compacte une structure dtime en un entier long compos de 2 champs
    date et temps de composition analogue  ceux de la strucure ffblk, .
  SYNTAXE:
    #include <wmlib.h>
    unsigned long dtimetolft(struct dtime *_dt)
  PROTOTYPE DANS
    wmlib.h
  DESCRIPTION:
    Un entier long est form  partir de 2 entiers de poids fort (date) et de
    poids faible (temps) structurs selon les champs de bits des champs
    ff_fdate et ff_ftime de la structure ffblk. Les donnes proviennent d'une
    structure dtime passe en paramtre.
  VALEUR(S) PASSEE(S):
    Un pointeur sur une structure dtime.
  VALEUR RETOURNEE:
    Un entier long non sign.
  CONTROLE:
    Aucun
  VOIR AUSSI
    datetemps_ftime(), ftime_datetemps(), convert2int()
  PROGRAMME EXEMPLE:
    EXDTEMPS.C
  ========================================================================*/
unsigned long dtimetolft(struct dtime *_dt)
{
  unsigned long l_ff;
  struct ftime ft;

  ft = dtimetoftime(_dt);
  l_ff = ( (long)ft.ft_year   << 25) /* ne pas oublier (long) car le dcalage */
         + ((long)ft.ft_month << 21) /* s'effectue sur un int (16 bits)!      */
         + ((long)ft.ft_day   << 16)
         + ((long)ft.ft_hour  << 11)
         + ((long)ft.ft_min   << 5)
         + ft.ft_tsec;
  return l_ff;
}
/*man=====================================================================
  errexit()
  ------------------------------------------------------------------------
  ACTION:
    Sortie du programme avec message d'erreur
  SYNTAXE:
    #include <wmlib.h>
    void errexit(byte _i)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Sort du programme avec un message d'erreur indiquant que les variables
    systmes n'ont pas t initialises par l'appel de wmlibinit().
    Cette fonction ne doit, en principe, jamais servir car wmlibinit()
    est toujours xcut au dmarrage grce  la directive #pragma startup
  VALEUR(S) PASSEE(S):
    Code d'erreur
  VALEUR RETOURNEE:
    Aucune
  CONTROLE:
    Aucune
  VOIR AUSSI:
    wmlibinit()
  PROGRAMME EXEMPLE:

  ========================================================================*/
void errexit(byte _i)
{
  char *msg[] =
  { "Valeur de videoseg (segment vido) non initialise!",
    "Valeur de videocard (carte vido) non initialise" };
  fprintf(stderr, "\x07\nERREUR! %s\n", msg[_i-1] );
  exit(_i);
}
/*man=====================================================================
  frame()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Trace un cadre
  SYNTAXE:
    #include <wmlib.h>
    void frame(byte __X1, byte __Y1, byte __X2, byte __Y2, byte __type_cadre,
      byte __coul_car, byte __coul_fond, boolean __ombrage, boolean __efface)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Trace un cadre en grant ventuellement l'ombrage et l'effacement de la
    zne intrieure dlimite (la couleur du fond est alors __coul_fond)
  VALEUR(S) PASSEE(S):
    Coordonnes cran de type byte: __X1, __Y1, __X2, __Y2, le type de cadre de type
    byte ( choisir dans l'enum TYPE_CADRE)
  VALEUR RETOURNEE:
    Aucune
  CONTROLE:
    Si la variable globale videoseg n'est pas initialise, branchement sur
    errexit()
  VOIR AUSSI:

  PROGRAMME EXEMPLE:
    EXGETSTR.C
  ========================================================================*/
void frame(byte __X1, byte __Y1, byte __X2, byte __Y2, byte __type_cadre,
  byte __coul_car, byte __coul_fond, boolean __ombrage, boolean __efface)
{
  int attr_org;
  register i;
  unsigned char motif[7][8] = { "       ",   /* ne pas oublier 'unsigned'    */
                                "ڿĳ",   /* sinon il y a des bogues avec */
                                "ɻȼͺ",   /* l'oprateur de dcalage <<   */
                                "",
                                "",
                                "",
                                ""};

  if (videoseg == 0) errexit(1);
  if (__efface == TRUE)
  {
    attr_org = info_text.attribute;
    textattr((__coul_fond << 4) + __coul_car);
    window(__X1, __Y1, __X2, __Y2);
    clrscr();
    window(1, 1, info_text.screenwidth, info_text.screenheight);
    textattr(attr_org);
  }
  if (__ombrage == TRUE)
  {
    for (i = __Y1; i <= __Y2; i++)
    {
      pokeb(videoseg, (160 * i) + (__X2 * 2) + 1,
        (BLACK << 4) + DARKGRAY);
      pokeb(videoseg, (160 * i+2) + (__X2 * 2) + 1,
        (BLACK << 4) + DARKGRAY);
    }
    for (i = __X1+1; i <= __X2; i++)
       pokeb(videoseg, (160 * __Y2) + (i * 2) + 1,
        (BLACK << 4) + DARKGRAY);
  }
    /* Dessin des quatres coins */
  poke(videoseg, (160 * (__Y1 - 1)) + ((__X1 - 1) * 2), (__coul_fond << 12) +
    (__coul_car << 8) + motif[__type_cadre][0]);
  poke(videoseg, (160 * (__Y1 - 1)) + ((__X2 - 1) * 2), (__coul_fond << 12) +
    (__coul_car << 8) + motif[__type_cadre][1]);
  poke(videoseg, (160 * (__Y2 - 1)) + ((__X1 - 1) * 2), (__coul_fond << 12) +
    (__coul_car << 8) + motif[__type_cadre][2]);
  poke(videoseg, (160 * (__Y2 - 1)) + ((__X2 - 1) * 2), (__coul_fond << 12) +
    (__coul_car << 8) + motif[__type_cadre][3]);

    /* Trac des lignes horizontales */
  for (i = __X1; i <= (__X2 - 2); i++)
  {
    poke(videoseg, (160 * (__Y1 - 1)) + (i * 2), (__coul_fond << 12) +
      (__coul_car << 8) + motif[__type_cadre][4]);
    poke(videoseg, (160 * (__Y2 - 1)) + (i * 2), (__coul_fond << 12) +
      (__coul_car << 8) + motif[__type_cadre][5]);
  }

    /* Trac des lignes verticales */
  for (i = __Y1; i <= (__Y2 - 2); i++)
  {
    poke(videoseg, (160 * i) + ((__X1 - 1) * 2), (__coul_fond << 12) +
      (__coul_car << 8) + motif[__type_cadre][6]);
    poke(videoseg, (160 * i) + ((__X2 - 1) * 2), (__coul_fond << 12) +
      (__coul_car << 8) + motif[__type_cadre][6]);
   }
}
/*man=====================================================================
  freelstchar()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Dtruit un tableau de pointeurs de pointeurs de char
  SYNTAXE:
    #include <wmlib.h>
    void freelstchar(int total, char **liste)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Le tableau est dtruit et la mmoire intgralement libre. Cette
    fonction est d'usage gnral pour ce type de tableau, en particulier
    celui retourn par mklstfile().
  VALEUR(S) PASSEE(S):
    Le nombre d'indices (= nombre des fichiers -1) et le pointeur sur le
    tableau
  VALEUR RETOURNEE:
    Aucune
  CONTROLE:
    Vrifie que le pointeur n'est pas NULL
  VOIR AUSSI:
    mklstfile()
  PROGRAMME EXEMPLE:
    EXMKLSTF.C
  ========================================================================*/
void freelstchar(int total, char **liste)
{
  int i;

    /* nettoyage de la boutique avant de fermer le rideau */
    /* le processus de libration de la mmoire s'effectue en ordre inverse
       de celui de l'allocation,  savoir:
       1) librer les pointeurs de fichiers,
       2) librer le pointeur de pointeurs */
  if (liste != NULL)
  {
    for (i = 0; i <= total; i++)
      free(liste[i]);
    free(liste);
  }
}
/*man=====================================================================
  freelstffblk()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Dtruit un tableau de pointeurs de pointeurs de structures ffblk
  SYNTAXE:
    #include <wmlib.h>
    void freelstffblk(int total, struct ffblk **liste)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Le tableau de structures ffblk, cr par mklstffblk() est dtruit et
    la mmoire intgralement libre.
  VALEUR(S) PASSEE(S):
    Le nombre d'indices (= nombre des structures -1) et le pointeur sur le
    tableau
  VALEUR RETOURNEE:
    Aucune
  CONTROLE:
    Vrifie que le pointeur n'est pas NULL
  VOIR AUSSI:
    mklstffblk()
  PROGRAMME EXEMPLE:
    EXMKLSTF.C
  ========================================================================*/
void freelstffblk(int total, struct ffblk **liste)
{
  int i;

    /* nettoyage de la boutique avant de fermer le rideau */
    /* le processus de libration de la mmoire s'effectue en ordre inverse
       de celui de l'allocation,  savoir:
       1) librer les pointeurs de fichiers,
       2) librer le pointeur de pointeurs */
  if (liste != NULL)
  {
    for (i = 0; i <= total; i++)
      free(liste[i]);
    free(liste);
  }
}
/*man=====================================================================
  freelstsdrive()
  ------------------------------------------------------------------------
  ACTION:
    Dtruit un tableau de pointeurs de structures sdrive
  SYNTAXE:
    #include <wmlib.h>
    void freelstsdrive(byte total, sdrive **liste)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Le tableau, cr par mklstsdrive() est dtruit et la mmoire intgralement
    libre.
  VALEUR(S) PASSEE(S):
    Le nombre d'indices (= nombre des lecteurs logiques -1) et le pointeur
    sur le tableau de structures sdrive.
  VALEUR RETOURNEE:
    Aucune
  CONTROLE:
    Vrifie que le pointeur n'est pas NULL
  VOIR AUSSI:
    mklstsdir()
  PROGRAMME EXEMPLE:
    EXMKLSTS.C
  ========================================================================*/
void freelstsdrive(byte total, sdrive **liste)
{
  byte i;

    /* nettoyage de la boutique avant de fermer le rideau */
    /* le processus de libration de la mmoire s'effectue en ordre inverse
       de celui de l'allocation,  savoir:
       1) librer les pointeurs de lecteurs,
       2) librer le pointeur de pointeurs */
  if (liste != NULL)
  {
    for (i = 0; i <= total; i++)
      free(liste[i]);
    free(liste);
  }
}
/*man=====================================================================
  ftimetodtime()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    conversion de structures ftime en dtime.
  SYNTAXE:
    #include <wmlib.h>
    struct dtime *ftimetodtime(struct ftime *ptr_ftime)
  PROTOTYPE DANS
    wmlib.h
  DESCRIPTION:
    Convertit une structure ftime (Borland) en structure dtime (W.M.)
  VALEUR(S) PASSEE(S):
    Un pointeur sur la structure ftime.
  VALEUR RETOURNEE:
    La structure dtime.
  CONTROLE:
    Retourne NULL si la structure ftime est NULL, pour le reste l'appelant
    doit s'assurer de la valeur des membres de la structure ftime.
  VOIR AUSSI
    dtimetoftime()
  PROGRAMME EXEMPLE:
    EXDTEMPS.C
  ========================================================================*/
struct dtime ftimetodtime(struct ftime *ptr_ftime)
{
  struct dtime pDt;

  pDt.dt_annee   = ptr_ftime->ft_year + 1980;
  pDt.dt_mois    = ptr_ftime->ft_month;
  pDt.dt_jour    = ptr_ftime->ft_day;
  pDt.dt_heure   = ptr_ftime->ft_hour;
  pDt.dt_minute  = ptr_ftime->ft_min;
  pDt.dt_seconde = ptr_ftime->ft_tsec * 2;
  return pDt;
}

/*man=====================================================================
  getdtimesys()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Retourne une structure dtime aprs lecture date et temps systme
  SYNTAXE:
    #include <wmlib.h>
    struct dtime *getdtimesys(void)
  PROTOTYPE DANS
    wmlib.h
  DESCRIPTION:
    Lecture de la date et temps systme.
  VALEUR(S) PASSEE(S):
    Aucune
  VALEUR RETOURNEE:
    Un pointeur sur une structure dtime
  CONTROLE:
    Aucun
  VOIR AUSSI
    getstrdatesys()
  PROGRAMME EXEMPLE:
    EXDTEMPS.C
  ========================================================================*/
struct dtime getdtimesys(void)
{
  struct dtime pDt;
  union REGS inregs, outregs;

  inregs.h.ah = 0x2A;
  intdos(&inregs, &outregs);
  pDt.dt_annee = outregs.x.cx;
  pDt.dt_mois  = outregs.h.dh;
  pDt.dt_jour  = outregs.h.dl;
  inregs.h.ah = 0x2C;
  intdos(&inregs, &outregs);
  pDt.dt_heure   = outregs.h.ch;
  pDt.dt_minute  = outregs.h.cl;
  pDt.dt_seconde = outregs.h.dh;
  return pDt;
}
/*man=====================================================================
  getmem()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Allocation mmoire
  SYNTAXE:
    #include <wmlib.h>
    void *getmem(int size)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Alloue de la mmoire avec la fonction malloc() en ayant pralablement
    test par coreleft() qu'il en reste suffisament.
  VALEUR(S) PASSEE(S):
    La taille (de type int)
  VALEUR RETOURNEE:
    Un pointeur sans type sur le bloc allou ou NULL si l'espace mmoire
    disponible est insuffisant.
  CONTROLE:
    Aucun
  VOIR AUSSI:

  PROGRAMME EXEMPLE:

  ========================================================================*/
void *getmem(int size)
{
  if (coreleft() < size) return NULL;
  return malloc(size);
}
/*man=====================================================================
  getstr()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Saisie sophistique de chane
  SYNTAXE:
    #include <wmlib.h>
    char *getstr(byte x, byte y, word LongTotale, wordLongSaisie,
    byte SaisieAttr, byteCoulTxt, byte CoulFond, char *EntreeChaine,
    byte *carclav, byte*codclav)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Saisie d'une chane  une position dfinie de l'cran et d'une longueur
    dtermine. Possibilit de scrolling si la longueur de saisie est
    infrieure  la longueur totale. La couleur de la saisie est dtermine.
    Un attribut de saisie permet de majusculiser (y compris les minuscules
    accentues franaises) ou de limiter la saisie aux seuls chiffres
    (point compris). Une chane pralable peut tre passe. Les codes ASCII
    et clavier de la touche ayant autoris la sortie de la fonction sont
    passs aux pointeurs carclav et codclav qui, bien qu'apparaissant en
    tant que paramtres, ne sont ventuellement utiles que par leurs valeurs
    retournes.
    Touches d'dition utilisables: flche gauche, flche droite, retour
    arrire, suppression, dbut, fin.
    Touches de sortie de la saisie: ENTER, ESC, flche haute, flche basse,
    Ctrl-I, Ctrl-S
  VALEUR(S) PASSEE(S):
    x		  position x du dbut de la saisie
    y		  position y du dbut de la saisie
    LongTotale	  longueur totale de la chane
    LongSaisie	  longueur affiche  l'cran
    SaisieAttr	  code de l'attribut de saisie
    CoulTxt	  couleur des caractres
    CoulFond	  couleur du fond
    EntreeChaine  chane pralable
    carclav	  code ASCII de la sortie (pointeur)
    codclav	  code clavier de la sortie (pointeur)
  VALEUR RETOURNEE:
    Pointeur sur la chane saisie
  CONTROLE:
    Vrification des erreurs de coordonnes x et y
  VOIR AUSSI:

  PROGRAMME EXEMPLE:
    EXGSTR.C
  ========================================================================*/
char *getstr( byte x, byte y, word LongTotale, word LongSaisie,
  byte SaisieAttr, byte CoulTxt, byte CoulFond, char *EntreeChaine,
  byte *carclav, byte *codclav )
{
    /* variables internes de la fonction */
  extern struct text_info info_text;  /* variable prdfinie de type text_info */
  byte    DepartAttr;                 /* conservation de l'attribut de couleur */
  boolean Sortie;                     /* autorisation de sortir de la fonction */
  boolean fenetrage;                  /* scrolling ou non */
  byte    fin_tableau;                /* nb de car. du tableau */
  byte    pos_tableau;                /* index en cours dans le tableau */
  byte    i;                          /* compteur d'itration */
  static  char tableau[256];          /* tableau prdimentionn  255 car. */
  struct  text_info info;             /* la structure texte */

    /* s'il y a un marqueur de scrolling la saisie commence aprs lui */
    if (LongSaisie < LongTotale) x++;

    /* traitement des erreurs de paramtres */
  if ( y < 1 || x < 1 || x > 77 || (80 - x - LongSaisie) <= 0 )
  {
    drelin();
    gotoxy(24,10);
    cputs("Erreur de paramtres dans getstr!");
    exit(0);
  }

    /* sauvegarde de l'attribut couleur courant */
  gettextinfo(&info);
  DepartAttr = info.attribute;

    /* initialisation de la valeur boolenne d'autorisation de sortie */
  Sortie = FALSE;

    /* Dtermination de la valeur boolenne de longueur de saisie infrieure
        la longueur totale possible */
  if (LongSaisie < LongTotale) fenetrage = TRUE;
  else fenetrage = FALSE;

    /* Fixation des couleurs passes en paramtres */
  textcolor(CoulTxt);
  textbackground(CoulFond);

    /* Affichage du masque de saisie */
  if (fenetrage)
  {
    gotoxy(x-1, y);
    repchar(LongSaisie + 3, ' ');    /* 3 caractres de plus */
  }
  else
  {
    gotoxy(x, y);
    repchar(LongSaisie, ' ');
  }

    /* Affichage ventuel de la chane pralable */
  gotoxy(x, y);
  fin_tableau = strlen(EntreeChaine);
  pos_tableau = fin_tableau + 1;
  if (fin_tableau > 0)                   /* si la chane pralable existe */
    for (i = 1; i <= fin_tableau; i++)
    {
      if (SaisieAttr == MAJUSCULE)
        tableau[i-1] = toupperfr(EntreeChaine[i-1]);
      else
        tableau[i-1] = EntreeChaine[i-1];
      gotoxy(x-1+i, y);
      putch(tableau[i-1]);
    }
  tableau[fin_tableau] = 0;          /* ne pas oublier le caractre d'arrt */

    /* Grande boucle de saisie */
  do
  {
    *carclav = getch();                      /* saisie du code ASCII */
    if (*carclav == 0) *codclav = getch();   /* saisie du code clavier */

      switch (*carclav)
      {
        case 0 :
          switch (*codclav)
          {
            case 71 :
              debut(fin_tableau, LongSaisie, x, y, &pos_tableau, tableau);
              break;
            case 75 :
              gauche(fin_tableau, LongSaisie, x, y, &pos_tableau, tableau,
                LongTotale);
              break;
            case 77 :
              droite(fin_tableau, LongSaisie, x, y, &pos_tableau, tableau,
                LongTotale);
              break;
            case 79 :
              fin(fin_tableau, LongSaisie, x, y, &pos_tableau, tableau);
              break;
            case 82 :
              if (insertion == TRUE)
              {
                insertion = FALSE;
                showcursor();
              }
              else
              {
                insertion = TRUE;
                squarecursor();
              }
              break;
            case 83 :
              suppression(&fin_tableau, LongSaisie, x, y, pos_tableau, tableau);
              break;
          }
          break;
        case 8 :
          marche_arriere(&fin_tableau, LongSaisie, x, y, &pos_tableau, tableau,
            LongTotale);
          break;
        default :
          if ( ( (SaisieAttr == NUMERIQUE)
                 && (*carclav >= 48 && *carclav <= 57)
                 || *carclav == '.')
               ||
                 ( (SaisieAttr != NUMERIQUE)
                 && (*carclav >= 32 && (unsigned)*carclav <= 255)))
            {
              saisie(&fin_tableau, LongSaisie, x, y, &pos_tableau, tableau,
                LongTotale, *carclav, SaisieAttr);
              break;
            }
            else break;
      }

      /* Les diffrents cas d'autorisation de sortie
          traiter par la routine appelant getstr().
         Par exemple:
         si ENTER: saisie valide
         si ESC: rien n'est chang
         si Ctrl-S: effacement                        */

    switch (*carclav)
    {
      case 13 : /* ENTER  */        Sortie = TRUE; break;
      case  9 : /* Ctrl-I ou TAB */ Sortie = TRUE; break;
      case 27 : /* ESC    */        Sortie = TRUE; break;
      case 19 : /* Ctrl-S */        Sortie = TRUE; break;
      case  0 :
        switch (*codclav)
        {
	  case 72 : /* f. haut */ Sortie = TRUE; break;
          case 80 : /* f. bas  */ Sortie = TRUE; break;
        }
    }

  } while (!Sortie);

    /* Prparatifs de retour */
  if (insertion == TRUE) showcursor(); /* restituer le curseur normal */
  textattr(DepartAttr);              /* restituer les attributs de couleur */

    /* Tronquer les espaces ventuels  droite */
  while (tableau[fin_tableau-1] == ' ')
    fin_tableau--;

    /* Tronquer les espace ventuels  gauche */
  while (tableau[0] == ' ')
  {
    for (i=0; i<=(fin_tableau-2); i++)
      tableau[i] = tableau[i+1];
    fin_tableau--;
  }
  tableau[fin_tableau] = 0;          /* il faut savoir terminer une chane */
  return tableau;
}

/*man=====================================================================
  repchar()     fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Rpte l'affichage d'un caractre.
  SYNTAXE:
    #include <wmlib.h>
    void repchar(byte n, char c)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Rpte n fois le caractre c  partir de la position courante du curseur
    dans l'attribut de couleur courant.
  VALEUR(S) PASSEE(S):
    Le nombre n et le caractre c
  VALEUR RETOURNEE:
    Aucune
  CONTROLE:
    Aucun
  VOIR AUSSI:

  PROGRAMME EXEMPLE:

  ========================================================================*/
void repchar(byte n, char c)
{
  byte i;
  for (i = 1; i <= n; i++) putch(c);
}

/*========================================================================
  debut()      fonction prive de getstr()
  ------------------------------------------------------------------------
  EFFET:
    Positionne le curseur sur le premier caractre de la chane.
  SYNTAXE:
    Ne pas utiliser cette fonction
  DESCRIPTION:
    Utilise les variables de la fonction passes par valeur ou par adresse
    selon la possibilit de modification
  VALEUR RETOURNEE:
    Aucune.
  CONTROLE:
    Aucun.
  ========================================================================*/
static void debut(byte fin_tableau, byte LongSaisie, byte x, byte y,
  byte *pos_tableau, char tableau[81])
{
  byte i;

  if (fin_tableau <= LongSaisie)
    gotoxy(x, y);
  else
  {
    gotoxy(x + LongSaisie + 1, y);
    if (fin_tableau == LongSaisie + 1)
      putch(' ');
    else
      putch(16);
    for (i = 1; i <= (LongSaisie + 1); i++)
    {
      gotoxy(x-1+i, y);
      putch(tableau[i-1]);
    }
    gotoxy(x-1, y);
    putch(' ');
  }
  *pos_tableau = 1;
}

/*========================================================================
  gauche()      fonction prive de getstr()
  ------------------------------------------------------------------------
  EFFET:
    Recule le curseur d'un caractre (on est en mode refrappe).
  SYNTAXE:
    Ne pas utiliser cette fonction
  DESCRIPTION:
    Utilise les variables de la fonction passes par valeur ou par adresse
    selon la possibilit de modification
  VALEUR RETOURNEE:
    Aucune.
  CONTROLE:
    Aucun.
  ========================================================================*/
static void gauche(byte fin_tableau, byte LongSaisie, byte x, byte y,
  byte *pos_tableau, char tableau[81], byte LongTotale)
{
  byte i;
  byte pos_curseur;

  if (*pos_tableau > 1)
  {
      /* Cas simple: la longueur totale n'excde pas la longueur saisie */
    if (LongTotale <= LongSaisie)
    {
      (*pos_tableau)--;
      gotoxy(x -1 + *pos_tableau, y);
    }

      /* La longueur totale est plus grande que la longueur de saisie */
    else
    {
        /* On conserve la position x du curseur */
      pos_curseur = wherex();

        /* La position est-elle plus grande que ce qui est affich? */
      if (*pos_tableau > (pos_curseur - x))

          /* Si le curseur n'est pas au dbut de la zne de saisie */
        if ((pos_curseur - x) > 0)
        {
          (*pos_tableau)--;              /* dcrmenter la position */
          gotoxy(pos_curseur - 1, y);    /* ainsi que le curseur    */
        }

          /* sinon on est au dbut de la zne de saisie */
        else
        {
          (*pos_tableau)--;              /* dcrmenter la position */
          for (i = 1; i <= (LongSaisie + 1); i++)
          {
            gotoxy(x - 1 + i, y);      /* afficher la chane... */
            putch(tableau[*pos_tableau - 2 + i]); /* ... un lment avant */
          }
          gotoxy(pos_curseur, y);      /* on garde le curseur  sa place */

            /* Suppression du marqueur de dpassement  gauche */
          if (*pos_tableau == 1)
          {
            gotoxy(x - 1, y);
            putch(' ');
            gotoxy(pos_curseur, y);     /* retour  la position */
          }

            /* Positionnement ventuel du marqueur de dpassement  droite */
          if ((*pos_tableau + LongSaisie) < fin_tableau)
          {
            gotoxy(x + LongSaisie + 1, y);
            putch(16);
            gotoxy(pos_curseur, y);     /* retour  la position */
          }
        } /* if ((pos_curseur - x) > 0) */
    } /* if (LongTotale <= LongSaisie) */
  } /* if (*pos_tableau > 1) */
}

/*========================================================================
  droite()      fonction prive de getstr()
  ------------------------------------------------------------------------
  EFFET:
    Avance le curseur d'un caractre (on est en mode refrappe).
  SYNTAXE:
    Ne pas utiliser cette fonction
  DESCRIPTION:
    Utilise les variables de la fonction passes par valeur ou par adresse
    selon la possibilit de modification
  VALEUR RETOURNEE:
    Aucune.
  CONTROLE:
    Aucun.
  ========================================================================*/
static void droite(byte fin_tableau, byte LongSaisie, byte x, byte y,
  byte *pos_tableau, char tableau[81], byte LongTotale)
{
  byte pos_curseur;
  byte i;

  if (*pos_tableau < (fin_tableau + 1))
  {

      /* Cas simple: la longueur n'excde pas la longueur saisie */
    if (LongTotale <= LongSaisie)
    {
      (*pos_tableau)++;
      gotoxy(x - 1 + *pos_tableau, y);
    }

      /* la longueur totale excde la longueur de saisie */
    else
    {

        /* conserver la position du curseur */
      pos_curseur = wherex();

        /* la position est-elle plus grande que ce qui est affich */
      if (*pos_tableau > (pos_curseur - x))

          /* si le curseur n'est pas  la fin de la zne de saisie */
        if ((pos_curseur - x) < LongSaisie)
        {
          (*pos_tableau)++;             /* incrmenter l'index */
          gotoxy(pos_curseur + 1, y);   /* ainsi que le curseur */
        }

          /* sinon on est  la fin de la zne de saisie */
        else
        {
          (*pos_tableau)++;              /* incrmenter l'index */
          for (i = 1; i <= (LongSaisie + 1); i++) /* afficher la chane... */
          {
            gotoxy(x - 1 + i, y);        /* ... un lment aprs */

              /* le car.  afficher est-il aprs la fin du tableau? */
            if ((*pos_tableau - LongSaisie - 1 + i) == (fin_tableau + 1))
              putch(' ');                /* Oui, afficher un espace */
            else                         /* Non, afficher le car. */
              putch(tableau[*pos_tableau - LongSaisie - 2 + i]);
          }
        gotoxy(pos_curseur, y);          /* repositionnement  sa place */

          /* Suppression du marqueur de dpassement  droite */
        if (*pos_tableau == fin_tableau)
        {
          gotoxy(x + LongSaisie + 1, y);
          putch(' ');
          gotoxy(pos_curseur, y);        /* retour  sa place */
        }

          /* Positionnement ventuel du marqueur de dpassement  gauche */
        if ((*pos_tableau - LongSaisie -1) > 0)
        {
          gotoxy(x - 1, y);
          putch(17);
          gotoxy(pos_curseur, y);        /* retour  sa place */
        }
      }
    } /* if (LongTotale <= LongSaisie) */
  } /* if (*pos_tableau < (fin_tableau + 1)) */
}

/*========================================================================
  fin()      fonction prive de getstr()
  ------------------------------------------------------------------------
  EFFET:
    Positionne le curseur sur le dernier caractre de la chane.
  SYNTAXE:
    Ne pas utiliser cette fonction
  DESCRIPTION:
    Utilise les variables de la fonction passes par valeur ou par adresse
    selon la possibilit de modification
  VALEUR RETOURNEE:
    Aucune.
  CONTROLE:
    Aucun.
  ========================================================================*/
static void fin(byte fin_tableau, byte LongSaisie, byte x, byte y,
  byte *pos_tableau, char tableau[81])
{
  byte i;

  if (fin_tableau <= LongSaisie)
    gotoxy(x + fin_tableau, y);
  else
  {
    gotoxy(x - 1, y);
    putch(17);
    gotoxy(x + LongSaisie + 1, y);
    putch(' ');
    gotoxy(x + LongSaisie, y);
    putch(' ');
    for (i = LongSaisie; i >= 1; i--)
    {
      gotoxy(x + LongSaisie - i, y);
      putch(tableau[fin_tableau - i]);
    }
    gotoxy(x + LongSaisie, y);
  }
  *pos_tableau = fin_tableau + 1;
}

/*========================================================================
  marche_arriere()      fonction prive de getstr()
  ------------------------------------------------------------------------
  EFFET:
    Destruction du caractre en marche arrire
  SYNTAXE:
    Ne pas utiliser cette fonction
  DESCRIPTION:
    Utilise les variables de la fonction passes par valeur ou par adresse
    selon la possibilit de modification
  VALEUR RETOURNEE:
    Aucune.
  CONTROLE:
    Aucun.
  ========================================================================*/
static void marche_arriere(byte *fin_tableau, byte LongSaisie, byte x, byte y,
  byte *pos_tableau, char tableau[81], byte LongTotale)
{
  byte i;
  byte pos_curseur;
  byte x1;

  if ((*fin_tableau > 0) && (*pos_tableau > 1))   /* limites d'emploi */
  {
      /* Cas simple: la longueur totale n'xcde pas la longueur de saisie */
    if (LongTotale <= LongSaisie)
    {
      gotoxy(x - 1 + *pos_tableau - 1, y); /* position sur le car.  supprimer */
      pos_curseur = wherex();        /* sauvegarde de la pos. du curseur */
      (*fin_tableau)--;              /* dcrmenter la position courante */
      (*pos_tableau)--;              /* dcrmenter la longueur */
      for (i = *pos_tableau; i <= *fin_tableau; i++)
      {                              /* depuis la position courante: */
        gotoxy(x - 1 + i, y);
        tableau[i-1] = tableau[i];   /* 1) faire glisser les car.  gauche */
        putch(tableau[i-1]);         /* 2) les afficher */
      }
      putch(' ');                    /* effacer le car. final rsiduel */
      gotoxy(pos_curseur, y);        /* rcuprer la position du curseur */
    }
      /* Ce n'est pas le cas simple */
    else
        /* mais a revient au mme */
      if (*fin_tableau <= LongSaisie)
      {
        gotoxy(x - 1 + *pos_tableau - 1, y); /* position sur le car.  supprimer */
        pos_curseur = wherex();        /* sauvegarde de la pos. du curseur */
        (*fin_tableau)--;              /* dcrmenter la position courante */
        (*pos_tableau)--;              /* dcrmenter la longueur */
        for (i = *pos_tableau; i <= *fin_tableau; i++)
        {                              /* depuis la position courante: */
          gotoxy(x - 1 + i, y);
          tableau[i-1] = tableau[i];   /* 1) faire glisser les car.  gauche */
          putch(tableau[i-1]);         /* 2) les afficher */
        }
        putch(' ');                    /* effacer le car. final rsiduel */
        gotoxy(pos_curseur, y);        /* rcuprer la position du curseur */
      }
        /* ici vritable cas complexe */
      else
      {
        (*fin_tableau)--;       /* dcrmenter la longueur */
        (*pos_tableau)--;       /* dcrmenter la position courante */
        pos_curseur = wherex(); /* sauver la pos. du curseur */
          /* reconstituer le tableau */
        for (i = *pos_tableau; i <= *fin_tableau; i++)
          tableau[i-1] = tableau[i];

          /* si le 1er car de la fentre n'est pas le 1er du tableau */
        if ( (pos_curseur - x ) != *pos_tableau)
        {
            /* afficher  gauche de la supression */
          for (i = *pos_tableau, x1 = pos_curseur; i >= 1; i--, x1--)
          {
            if (x1 > x)
            {
              gotoxy(x1-1, y);
              putch(tableau[i - 2]);
              if ((i-2) == 0)         /* si on a affich le 1er caractre */
              {
                gotoxy(x-1, y);       /* supprimer le marqueur de */
                putch(' ');           /* dpassement  gauche */
              }
            }
          }
          
            /* cas du 1er car affich qui devient le premier du tableau */
          if ((pos_curseur - x) == 0 && *pos_tableau == 1)
          {
            gotoxy(x-1, y);       /* supprimer le marqueur de */
            putch(' ');           /* dpassement  gauche */
          }
          gotoxy(pos_curseur,y);   /* restituer la position courante du curseur */
        }
        else   /* le 1er car affich est le premier du tableau */
        {
            /* afficher  droite  partir de la suppression */
          gotoxy (wherex () - 1, y);
          for (i = *pos_tableau, x1 = 0;
            x1 <= (LongSaisie - pos_curseur +1 + x); x1++, i++)
          {
            if (i <= *fin_tableau)             /* si on est dans le tableau */
              putch (tableau[i-1]);            /* on affiche le caractre */
            else                               /* sinon */
            {
              putch(' ');                      /* on affiche un blanc */
            }
            if (i == *fin_tableau)             /* si dernier car  droite */
            {
              int savecurs = wherex ();        /* sauver la position */
              gotoxy(x + LongSaisie + 1, y);   /* supprimer le marqueur */
              putch(' ');                      /* de dpassement  droite */
              gotoxy (savecurs, y);            /* rcuprer la position */
            }
          }
          gotoxy (pos_curseur - 1, y);         /* rcupration de la pos - 1 */
        }
      }
  } /* if (*fin_tableau > 0) */
}

/*========================================================================
  supression()      fonction prive de getstr()
  ------------------------------------------------------------------------
  EFFET:
    Destruction du caractre sous le curseur
  SYNTAXE:
    Ne pas utiliser cette fonction
  DESCRIPTION:
    Utilise les variables de la fonction passes par valeur ou par adresse
    selon la possibilit de modification
  VALEUR RETOURNEE:
    Aucune.
  CONTROLE:
    Aucun.
  ========================================================================*/
static void suppression(byte *fin_tableau, byte LongSaisie, byte x, byte y,
  byte pos_tableau, char tableau[81])
{
  byte i;
  byte pos_curseur;

  if (*fin_tableau > 0)
  {

      /* ractualiser le tableau */
    for (i = pos_tableau; i <= *fin_tableau; i++)
      tableau[i-1] = tableau[i];
    (*fin_tableau)--;

      /* cas du tableau rduit  un caractre */
    if (*fin_tableau == 0)
    {
      putch (' ');                    /* on affiche un blanc */
      gotoxy (wherex () - 1, y);      /* on retourne o on tait */
      return;                         /* on sort */
    }

      /* conserver la position du curseur */
    pos_curseur = wherex();

      /* afficher le reste du tableau ou ce qui peut tenir dans la fentre */
    for (i = pos_tableau; i <= *fin_tableau; i++)
      if (wherex() <= (LongSaisie + x))
      {
        putch(tableau[i-1]);
        if (i == *fin_tableau)    /* Si on a affich le dernier caractre */
        {
          putch(' ');                     /* effacer l'ancien dernier car. */
          gotoxy(x + LongSaisie + 1, y);  /* et le marqueur */
          putch(' ');                     /* de dpassement  droite */
        }
      }

      /* retour  la position d'origine */
    gotoxy(pos_curseur, y);
  }
}

/*========================================================================
  saisie()      fonction prive de getstr()
  ------------------------------------------------------------------------
  EFFET:
    Mise en place du caractre dans la chane
  SYNTAXE:
    Ne pas utiliser cette fonction
  DESCRIPTION:
    Utilise les variables de la fonction passes par valeur ou par adresse
    selon la possibilit de modification
  VALEUR RETOURNEE:
    Aucune.
  CONTROLE:
    Aucun.
  ========================================================================*/
static void saisie(byte *fin_tableau, byte LongSaisie, byte x, byte y,
  byte *pos_tableau, char tableau[81], byte LongTotale, byte carclav,
  byte SaisieAttr)
{
  byte i, j;
  byte car;
  byte pos_curseur;

    /* 2 cas de figure: insertion active ou non */
    /* Cas 1: insertion inactive */
  if (!insertion)
  {
      /* Si l'on est positionn aprs le dernier lment du tableau */
    if (*pos_tableau > *fin_tableau)
      (*fin_tableau)++;

      /* Si l'on dpasse la limite on se positionne  la limite */
    if (*fin_tableau > LongTotale)
      *fin_tableau = LongTotale;

      /* Si le caractre doit tre une majuscule... */
    if (SaisieAttr == MAJUSCULE)
      car = toupperfr(carclav);
    else car = carclav;

      /* Si l'indice de position est avant la fin du tableau */
    if (*pos_tableau < *fin_tableau)
    {
      tableau[*pos_tableau - 1] = car;
      gotoxy(wherex(), wherey());
      putch(car);
      (*pos_tableau)++;
    }
      /* Sinon on traite l'entre comme tant aprs la fin du tableau */
    else
    {
      tableau[*fin_tableau-1] = car;
      (*pos_tableau)++;

        /* Cas simple: la longueur totale n'xcde pas la longueur de saisie */
      if (LongTotale <= LongSaisie)
      {
        gotoxy(x - 1 + *fin_tableau, y);
        putch(car);
      }

        /* La longueur totale est plus grande que la longueur de saisie */
      else

          /* Ce n'est pas la cas  ce stade */
        if (*fin_tableau <= LongSaisie)
        {
          gotoxy(x - 1 + *fin_tableau, y);
          putch(car);
        }

          /* Ca l'est devenu */
        else
        {
            /* positionner les marqueurs de dpassement */
          gotoxy(x-1, y);
          if (*fin_tableau > LongSaisie)
            putch(17);
          else
            putch(' ');
          for (i = LongSaisie; i >= 1; i--)
          {
            gotoxy(x + LongSaisie - i, y);
            putch(tableau[*fin_tableau - i]);
          }
        }
    }
      /* too much is too much */
    if (*pos_tableau > LongTotale+1)
      *pos_tableau = LongTotale+1;
  }

    /* Cas 2 : insertion active */
  else
  {
     (*fin_tableau)++;      /* dans tous les cas on incrmente */

       /* Mais si on dpasse la limite on se positionne  la limite */
    if (*fin_tableau > LongTotale)
    {
      *fin_tableau = LongTotale;
      cprintf("\a");                   /* tut! */
      return;                          /* et on refuse l'insertion */
    }

      /* Si le caractre doit tre une majuscule... */
    if (SaisieAttr == MAJUSCULE)
      car = toupperfr(carclav);
    else car = carclav;

      /* Dcalage  droite des lments et insertion du caractre */
    for(i = *fin_tableau; i >= *pos_tableau; i--)
      tableau[i] = tableau[i-1];
      /* *pos_tableau pointe toujours sur le caractre suivant (comme seek)
         donc si l'on n'a pas atteint la longueur totale on ajoute
         (*pos_tableau - 1) le caractre dans la chane */
    if (*pos_tableau <= LongTotale)
      tableau[*pos_tableau - 1] = car;
      /* sinon on remplace (*pos_tableau - 2) le dernier caractre de la
         chane */
    else
      tableau[*pos_tableau - 2] = car;

      /* sauvegarde de la position courante du curseur */
      /* S'il ne reste pas un unique car.  droite de la fentre */
    if (wherex() <= x + LongSaisie - 1)
      pos_curseur = wherex()+1;   /* la position sera aprs ce car. */
    else                          /* sinon */
      pos_curseur = wherex();     /* la position sera sur ce car. */

      /* Si l'on a pas atteint la longueur totale, positionner *pos_tableau
         sur l'lment suivant */
    if (*pos_tableau < LongTotale + 1) (*pos_tableau)++;

      /* Affichage */
      /* Convention: Un caractre insr dcale ceux de la chane situs
          droite, en les faisant disparaitre de la fentre au besoin,
         Jusqu'au moment o il n'en reste plus qu'un, auquel cas le dcalage
         se fait  gauche. */
      /* Si l'on n'est pas positionn avant le dernier car. de la fentre */
    if (wherex() <= x + LongSaisie - 1)
    {
        /* on affiche en dcalant  droite */
      for(i = *pos_tableau - 1; i <= *fin_tableau; i++)
        if(wherex() <= x + LongSaisie)
          putch(tableau[i-1]);
        /* positionnement du marqueur  droite */
      if( (*pos_tableau >= LongSaisie + 1) && (*pos_tableau < *fin_tableau) )
      {
        gotoxy(x + LongSaisie + 1, y);
        putch(16);
      }
    }
    else
      /* sinon on affiche en dcalant  gauche */
    {
      gotoxy(wherex() - 1, y);
      for(i = LongSaisie, j = *pos_tableau - 1; i > 0; i--, j--)
      {
        putch(tableau[j - 1]);
        gotoxy(wherex() - 2, y);
      }
        /* positionnement du marqueur de gauche */
      gotoxy(x-1, y);
      if(j >= 1) putch(17);
      else putch(' ');
    }

      /* rcupration de la position du curseur sauvegarde */
    gotoxy(pos_curseur, y);
  }
}

/*man=====================================================================
  getstrdatesys()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Fournit la date systme sous forme de chane
  SYNTAXE:
    #include <wmlib.h>
    char *getstrdatesys(void)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Compose une chane date de 15 caractres
  VALEUR(S) PASSEE(S):
    Aucune
  VALEUR RETOURNEE:
    La chane date sous forme "Nnn JJ/MM/AAAA" + '\x0'. (valeur static)
  CONTROLE:
    Aucun
  VOIR AUSSI:
    getstrtimesys()
  PROGRAMME EXEMPLE:
    EXDTEMPS.C
  ========================================================================*/
char *getstrdatesys(void)
{
  static char pDate[15];
  char *table_joursem[] =
    { "Dim", "Lun", "Mar", "Mer", "Jeu", "Ven", "Sam" };
  union REGS inregs, outregs;

  inregs.h.ah = 0x2A;
  intdos(&inregs, &outregs);
  sprintf(pDate, "%s %02d/%02d/%d", table_joursem[outregs.h.al],
    outregs.h.dl, outregs.h.dh, outregs.x.cx);
  return pDate;
}
/*man=====================================================================
  getstrtimesys()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Fournit le temps systme sous forme de chane
  SYNTAXE:
    #include <wmlib.h>
    char *getstrtimesys(void)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Compose une chane de 9 caractres.
  VALEUR(S) PASSEE(S):
    Aucune
  VALEUR RETOURNEE:
    La chane temps sous forme "HH:MM:SS" + '\x0'. (valeur static)
  CONTROLE:
    Aucun
  VOIR AUSSI:
    getstrdate()
  PROGRAMME EXEMPLE:
    EXDTEMPS.C
  ========================================================================*/
char *getstrtimesys(void)
{
  union REGS inregs, outregs;
  static char pTemps[9];

  inregs.h.ah = 0x2C;
  intdos(&inregs, &outregs);
  sprintf(pTemps, "%2d:%02d:%02d",
    outregs.h.ch, outregs.h.cl, outregs.h.dh);
  return pTemps;
}
/*man=====================================================================
  mklstffblk()    fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Cre un tableau de structures ffblk du rpertoire
  SYNTAXE:
    #include <wmlib.h>
    struct ffblk **mklstffblk(char *masque, char attribut, int*nombre,
      int tri)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Cre un tableau de structures ffblk sous forme dynamique et le trie 
    ventuellement. Cette fonction est plus puissante que mklstfile()
    qui ne fournit qu'un simple tableau de nom de fichiers tris par ordre
    alphabtique, mais consomme d'avantage de code et de mmoire.
  VALEUR(S) PASSEE(S):
    Un pointeur sur le masque de slection des fichiers, l'attribut des
    fichiers selon DOS, l'adresse d'une variable de type int qui recevra
    le nombre d'indices du tableau des fichiers trouvs (c-a-d le nombre
    des fichiers -1, 0 tant l'indice du premier fichier), le critre de tri
     choisir parmi TRI_SANS (pas de tri), TRI_NOM (tri selon le nom du
    fichier), TRI_DATE (tri en fonction de la date-temps du fichier),
    TRI_TAILLE_C et TRI_TAILLE_D (tri en ordre croissant ou dcroissant
    de taille) (enum dfinie dans WMLIB.H).
  VALEUR RETOURNEE:
    Un pointeur de pointeurs de structure ffblk des fichiers trouvs.
  CONTROLE:
    Retourne NULL en cas de problme d'allocation mmoire, d'erreur ou
    d'absence du premier fichier (en ce cas nombre vaut -1)
  VOIR AUSSI:
    freelstffblk(), mklstfile()
  PROGRAMME EXEMPLE:
    EXMKLSTF.C
  ========================================================================*/
struct ffblk **mklstffblk(char *masque, char attribut, int *nombre,
  int tri)
{
   struct ffblk ffblk;    /* structure de contrle des fichiers DOS */
   int erreur;            /* variable de contrle de lecture */
   struct ffblk **liste;

     /* Initialisation  1 pointeur (pour recevoir findfirst) */
   if ((liste = (struct ffblk **)malloc(sizeof(struct ffblk *))) == NULL)
     return NULL;

   *nombre = -1;                 /* initialisation du compteur */
     
   if ( (erreur = findfirst(masque, &ffblk, attribut)) == -1)
   {
     free(liste);     /* s'il n'y en a mme pas un: libration de la mmoire */
     return NULL;     /* et retour */
   }

   while (!erreur)    /* Si pas d'erreur, on continue */
   {
     if (attribut == FA_DIREC)    /* cas des rpertoires */
     {
       if (ffblk.ff_attrib & attribut)
       {
         ++(*nombre);
           /* 2 phases successives:
              1) attribution d'un espace mmoire pour les pointeurs en
                  fonction du nombre de fichiers trouvs */
         if ((liste = (struct ffblk **)realloc(liste, (*nombre+1) *
           sizeof(struct ffblk *))) == NULL)
           return NULL;
           /* 2) attribution d'un espace mmoire pour chaque pointeur de
                  fichiers et recopie de la structure ffblk */
         if ( (liste[*nombre] = (struct ffblk *)malloc(sizeof(struct ffblk))) == NULL)
           return NULL;
       }
     }
     else                        /* autres que des rpertoires */
     {
       ++(*nombre);
         /* 2 phases successives:
            1) attribution d'un espace mmoire pour les pointeurs en
                fonction du nombre de fichiers trouvs */
       if ((liste = (struct ffblk **)realloc(liste, (*nombre+1) *
         sizeof(struct ffblk *))) == NULL)
         return NULL;
         /* 2) attribution d'un espace mmoire pour chaque pointeur de
                fichiers et recopie de la structure ffblk */
       if ( (liste[*nombre] = (struct ffblk *)malloc(sizeof(struct ffblk)))
         == NULL)
         return NULL;
       *liste[*nombre] = ffblk;
     }
     erreur = findnext(&ffblk);   /* y en a-t-il encore ? */
   }

     /* tri avec shell et retour de la liste */
   switch(tri)
   {
     case TRI_SANS     : break;
     case TRI_NOM      : liste = shell_ffblk_ff_name(liste, *nombre+1); 
                         break;
     case TRI_DATE     : liste = shell_ffblk_ff_fdate(liste, *nombre+1); 
                         break;
     case TRI_TAILLE_D : liste = shell_ffblk_ff_fsize_d(liste, *nombre+1); 
                         break;
     case TRI_TAILLE_C : liste = shell_ffblk_ff_fsize_c(liste, *nombre+1); 
                         break;
   }
   return liste;
}

/*========================================================================
  shell_ffblk_ff_name()    fonction prive de cree_liste_dir()
  ------------------------------------------------------------------------
  EFFET:
    Tri d'un tableau de structures ffblk selon la mthode shell
    Tri sur ff_name.
  SYNTAXE:
    #include
    struct ffblk **shell_ffblk_ff_name(struct ffblk **base, int final)
    NE PAS UTILISER CETTE FONCTION
  DESCRIPTION:
    Valeurs passes: Le tableau de structures, la quantit  trier.
  VALEUR RETOURNEE:
    Le tableau de structure tri par nom de fichier.
  CONTROLE:
    Retourne NULL s'il y a des problmes d'allocation mmoire
  ========================================================================*/
static struct ffblk **shell_ffblk_ff_name(struct ffblk **base, int final)
{
  int i, j, pas;
  int count = 0;
  struct ffblk *working;

  for (pas = final / 2; pas > 0; pas /= 2)
    for (i = pas; i < final; i++)
      for (j = i - pas; j >= 0; j -= pas)
      {
        count += 1;
        if (compare(base[j]->ff_name, base[j + pas]->ff_name) <= 0)
          break;
        else
        {
            /* permutation classique de 2 variables avec l'aide d'une
               troisime */
          working       = base[j + pas];
          base[j + pas] = base[j];
          base[j]       = working;
        }
      }
  return(base);
}

/*========================================================================
  shell_ffblk_ff_fdate()    fonction prive de cree_liste_dir()
  ------------------------------------------------------------------------
  EFFET:
    Tri d'un tableau de structures ffblk selon la mthode shell
    Tri sur ff_fdate et ff_ftime.
  SYNTAXE:
    #include
    struct ffblk **shell_ffblk_ff_name(struct ffblk **base, int final)
    NE PAS UTILISER CETTE FONCTION
  DESCRIPTION:
    Valeurs passes: Le tableau de structures, la quantit  trier.
  VALEUR RETOURNEE:
    Le tableau de structure tri par date-temps des fichiers.
  CONTROLE:
    Retourne NULL s'il y a des problmes d'allocation mmoire
  ========================================================================*/
static struct ffblk **shell_ffblk_ff_fdate(struct ffblk **base, int final)
{
  int i, j, pas;
  int count = 0;
  struct ffblk *working;
  char str_ff_fdate[6];
  char str_ff_ftime[6];
  char date_temps1[11];
  char date_temps2[11];

  for (pas = final / 2; pas > 0; pas /= 2)
    for (i = pas; i < final; i++)
      for (j = i - pas; j >= 0; j -= pas)
      {
        count += 1;
        sprintf(date_temps1, "%5s%5s",
          ultoa(base[j]->ff_fdate, str_ff_fdate, 10),
          ultoa(base[j]->ff_ftime, str_ff_ftime, 10) );
        sprintf(date_temps2, "%5s%5s",
          ultoa(base[j+pas]->ff_fdate, str_ff_fdate, 10),
          ultoa(base[j+pas]->ff_ftime, str_ff_ftime, 10) );
        if(compare(date_temps1, date_temps2) <= 0)
          break;
        else
        {
            /* permutation classique de 2 variables avec l'aide d'une
               troisime */
          working       = base[j + pas];
          base[j + pas] = base[j];
          base[j]       = working;
        }
      }
  return(base);
}

/*========================================================================
  shell_ffblk_ff_fsize_d()    fonction prive de cree_liste_dir()
  ------------------------------------------------------------------------
  EFFET:
    Tri d'un tableau de structures ffblk selon la mthode shell
    Tri sur ff_size (ordre dcroissant).
  SYNTAXE:
    #include
    struct ffblk **shell_ffblk_ff_fsize_d(struct ffblk **base, int final)
    NE PAS UTILISER CETTE FONCTION
  DESCRIPTION:
    Valeurs passes: Le tableau de structures, la quantit  trier.
  VALEUR RETOURNEE:
    Le tableau de structure tri par taille de fichier (ordre dcroissant).
  CONTROLE:
    Retourne NULL s'il y a des problmes d'allocation mmoire
  ========================================================================*/
static struct ffblk **shell_ffblk_ff_fsize_d(struct ffblk **base, int final)
{
  int i, j, pas;
  int count = 0;
  struct ffblk *working;
  char str_fsize1[34];
  char str_fsize2[34];

  for (pas = final / 2; pas > 0; pas /= 2)
    for (i = pas; i < final; i++)
      for (j = i - pas; j >= 0; j -= pas)
      {
        count += 1;
        ultoa(base[j]->ff_fsize, str_fsize1, 10);
        ultoa(base[j+pas]->ff_fsize, str_fsize2, 10);
        if (compare(str_fsize1, str_fsize2) >= 0)
          break;
        else
        {
            /* permutation classique de 2 variables avec l'aide d'une
               troisime */
          working       = base[j + pas];
          base[j + pas] = base[j];
          base[j]       = working;
        }
      }
  return(base);
}

/*========================================================================
  shell_ffblk_ff_fsize_c()    fonction prive de cree_liste_dir()
  ------------------------------------------------------------------------
  EFFET:
    Tri d'un tableau de structures ffblk selon la mthode shell
    Tri sur ff_size(ordre croissant).
  SYNTAXE:
    #include
    struct ffblk **shell_ffblk_ff_fsize_c(struct ffblk **base, int final)
    NE PAS UTILISER CETTE FONCTION
  DESCRIPTION:
    Valeurs passes: Le tableau de structures, la quantit  trier.
  VALEUR RETOURNEE:
    Le tableau de structure tri par taille de fichier (ordre croissant).
  CONTROLE:
    Retourne NULL s'il y a des problmes d'allocation mmoire
  ========================================================================*/
static struct ffblk **shell_ffblk_ff_fsize_c(struct ffblk **base, int final)
{
  int i, j, pas;
  int count = 0;
  struct ffblk *working;
  char str_fsize1[34];
  char str_fsize2[34];

  for (pas = final / 2; pas > 0; pas /= 2)
    for (i = pas; i < final; i++)
      for (j = i - pas; j >= 0; j -= pas)
      {
        count += 1;
        ultoa(base[j]->ff_fsize, str_fsize1, 10);
        ultoa(base[j+pas]->ff_fsize, str_fsize2, 10);
        if (compare(str_fsize1, str_fsize2) <= 0)
          break;
        else
        {
            /* permutation classique de 2 variables avec l'aide d'une
               troisime */
          working       = base[j + pas];
          base[j + pas] = base[j];
          base[j]       = working;
        }
      }
  return(base);
}

/*========================================================================
  compare()    fonction prive utilise par les fonctions shell_ffblk...
  ------------------------------------------------------------------------
  EFFET:
    Compare 2 chanes
  SYNTAXE:
    #include <wmlib.h>
    int compare( const void *a, const void *b)
  DESCRIPTION:
    Compare 2 chanes
    NE PAS UTILISER CETTE FONCTION
  VALEUR RETOURNEE:
    La valeur de strcmp()
  CONTROLE:
    Aucun
  ========================================================================*/
static int compare( const char *a, const char *b)
{
   return( strcmp(a,b) );
}
/*man=====================================================================
  mklstfile()    fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Cre un tableau des fichiers du rpertoire
  SYNTAXE:
    #include <wmlib.h>
    char **mklstfile(char *masque, char attribut, int*nombre)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Cre un tableau des fichiers sous forme dynamique et le trie par ordre
    alphabtique.
  VALEUR(S) PASSEE(S):
    Un pointeur sur le masque de slection des fichiers, l'attribut des
    fichiers selon DOS, l'adresse d'une variable de type int qui recevra
    le nombre d'indices du tableau des fichiers trouvs (c-a-d le nombre
    des fichiers -1, 0 tant l'indice du premier fichier).
  VALEUR RETOURNEE:
    Un pointeur de pointeurs de char, autrement dit un tableau dynamique
    des fichiers trouvs
  CONTROLE:
    Retourne NULL en cas de problme d'allocation mmoire, d'erreur ou
    d'absence du premier fichier (en ce cas nombre vaut -1)
  VOIR AUSSI:
    freelstchar()
  PROGRAMME EXEMPLE:
    EXMKLSTF.C
  ========================================================================*/
char **mklstfile(char *masque, char attribut, int *nombre)
{
   struct ffblk ffblk;    /* structure de contrle des fichiers DOS */
   int erreur;            /* variable de contrle de lecture */
   char **liste;

     /* Initialisation  1 pointeur (pour recevoir findfirst) */
   if ((liste = (char **)malloc(sizeof(char *))) == NULL)
     return NULL;                        

   *nombre = -1;                 /* initialisation du compteur */
     
   if ( (erreur = findfirst(masque, &ffblk, attribut)) == -1)
   {
     free(liste);     /* s'il n'y en a mme pas un: libration de la mmoire */
     return NULL;     /* et retour */
   }

   while (!erreur)    /* Si pas d'erreur, on continue */
   {
     if (attribut == FA_DIREC)    /* cas des rpertoires */
     {
       if (ffblk.ff_attrib & attribut)
       {
         ++(*nombre);
           /* 2 phases successives:
              1) attribution d'un espace mmoire pour les pointeurs en
                  fonction du nombre de fichiers trouvs */
         if ((liste = (char **)realloc(liste, (*nombre+1) * sizeof(char *)))
           == NULL)
           return NULL;
           /* 2) attribution d'un espace mmoire pour chaque pointeur de
                  fichiers et recopie du nom du fichier */
         if ( (liste[*nombre] = strdup(ffblk.ff_name)) == NULL)
           return NULL;
       }
     }
     else                        /* autres que des rpertoires */
     {
       ++(*nombre);
         /* 2 phases successives:
            1) attribution d'un espace mmoire pour les pointeurs en
                fonction du nombre de fichiers trouvs */
       if ((liste = (char **)realloc(liste, (*nombre+1) * sizeof(char *)))
         == NULL)
         return NULL;
         /* 2) attribution d'un espace mmoire pour chaque pointeur de
                fichiers et recopie du nom du fichier */
       if ( (liste[*nombre] = strdup(ffblk.ff_name)) == NULL)
         return NULL;
     }
     erreur = findnext(&ffblk);   /* y en a-t-il encore ? */
   }

     /* tri avec shell et retour de la liste */
   return(shell(liste, *nombre+1));
}

/*========================================================================
  shell()    fonction prive de mklstfile()
  ------------------------------------------------------------------------
  EFFET:
    Tri d'un tableau de chanes selon la mthode shell
    Application  un tableau de pointeurs de chanes.
  SYNTAXE:
    #include
    char **shell(char **base, int final)
    NE PAS UTILISER CETTE FONCTION
  DESCRIPTION:
    Valeurs passes: Le tableau de chanes, la quantit  trier.
  VALEUR RETOURNEE:
    Le tableau tri.
  CONTROLE:
    Retourne NULL s'il y a des problmes d'allocation mmoire
  ========================================================================*/
static char **shell(char **base, int final)
{
  int i, j, pas;
  int count = 0;
  char *working;

  for (pas = final / 2; pas > 0; pas /= 2)
    for (i = pas; i < final; i++)
      for (j = i - pas; j >= 0; j -= pas)
      {
        count += 1;
        if (compare(base[j], base[j + pas]) <= 0)
          break;
        else
        {
            /* permutation classique de 2 variables avec l'aide d'une
               troisime, compliqu par le fait qu'il s'agit, ici, de
               pointeurs qu'il faut pralablement dsallouer */
          if ((working = strdup(base[j + pas])) == NULL)
            return(NULL);
          free(base[j + pas]);
          if ((base[j + pas] = strdup(base[j])) == NULL)
            return(NULL);
          free(base[j]);
          if ((base[j] = strdup(working)) == NULL)
            return(NULL);
          free(working);
        }
      }
    /* pas de problme de mmoire, on peut retourner la liste trie */
  return(base);
}

/*man=====================================================================
  mklstsdrive()    fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Renseigne sur le nombre de lecteurs logiques ainsi que leur nature
  SYNTAXE:
    #include <wmlib.h>
    sdrive **mklstsdrive(void)
  PROTOTYPE DANS
    wmlib.h
  DESCRIPTION:
    La fonction renseigne la variable globale maxdrive et retourne un
    tableau de structures sdrive
  VALEUR(S) PASSE(S):
    Aucune
  VALEUR RETOURNEE:
    Un pointeur de pointeurs (donc un tableau) de type sdrive (voir ce type)
  CONTROLE:
    Retourne NULL en cas de problme d'allocation mmoire
  VOIR AUSSI:
    freelstsdrive()
  PROGRAMME EXEMPLE:
    EXMKLSTS.C
  ========================================================================*/
sdrive **mklstsdrive(void)
{
  union REGS inregs, outregs;
  unsigned char dr, startdrive;
  sdrive **tableau_lecteurs;

  startdrive = getdisk();            /* ne pas perdre le lecteur d'origine */
  maxdrive = setdisk(startdrive);    /* combien peut-il en avoir? */

    /* attribuer maxdrive pointeurs de structure sinon on sort */
  if ( (tableau_lecteurs = (sdrive **)calloc(maxdrive, sizeof(sdrive *)))
    == NULL)
    return NULL;
  else
  {
    for (dr = 0; dr <= (maxdrive -1); dr++)
    {
      setdisk(dr);
        /* attribuer la taille de la structure  chaque pointeur sinon
           on sort */
      if( (tableau_lecteurs[dr] = (sdrive *)malloc(sizeof(sdrive))) == NULL)
        return NULL;
      tableau_lecteurs[dr]->drive = dr;   /* attribution du N de disque */
      if (dr == getdisk())                /* Est-ce un disque physique ? */
      {
        inregs.x.ax = 0x4409;		/* IOCTL function 9 */
        inregs.h.bl = dr+1;
        intdos(&inregs, &outregs);
        if (!outregs.x.cflag)
        {
          if (outregs.x.dx & 0x1000)
            tableau_lecteurs[dr]->nature = NETWORK;
          else
            if (outregs.x.dx == 0x0800)
              tableau_lecteurs[dr]->nature = RAMDISK;
            else
              tableau_lecteurs[dr]->nature = NORMAL; /* dx == 0x842 */
        }
        else
        {
          printf("Erreur de la fonction!");
          return NULL;
        }
      }
      else    /* sinon il s'agit d'un disque fictif */
        tableau_lecteurs[dr]->nature = FICTIF;
    }
    setdisk(startdrive);     /* se repositionner sur le lecteur d'origine */
  return tableau_lecteurs;   /* retourner le tableau document */
  }
}

/*man=====================================================================
  mousearea()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Dlimite un enclos pour la souris
  SYNTAXE:
    #include <wmmouse.h>
    void mousearea(word x1, word y1, word x2, word y2)
  PROTOTYPE DANS:
    wmmouse.h
  DESCRIPTION:
    Dlimite un rectangle cran que la souris ne peut franchir.
  VALEUR(S) PASSEE(S):
    Les coordonnes de l'enclos x1, y1, x2, y2
  VALEUR RETOURNEE:
    Aucune
  CONTROLE:
    Aucun
  VOIR AUSSI:
    Les fonctions mouse...
  PROGRAMME EXEMPLE:
    EXMOUSE.C
  ========================================================================*/
void mousearea(word x1, word y1, word x2, word y2)
{
  union REGS inregs, outregs;

  inregs.x.ax = 0x0007;
  inregs.x.cx = (x1 - 1) << 3;
  inregs.x.dx = (x2 - 1) << 3;
  int86(0x33, &inregs, &outregs);
  inregs.x.ax = 0x0008;
  inregs.x.cx = (y1 - 1) << 3;
  inregs.x.dx = (y2 - 1) << 3;
  int86(0x33, &inregs, &outregs);
}

/*man=====================================================================
  mousecurtxt()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Dfinit le curseur texte
  SYNTAXE:
    #include <wmmouse.h>
    void mousecurtxt(boolean curelec, word masqueAND, word masqueXOR)
  PROTOTYPE DANS:
    wmmouse.h
  DESCRIPTION:
    Le curseur texte est dfinit par un paramtre boolen TRUE (0) pour un
    curseur lectronique, FALSE(1) pour un curseur logiciel et par 2 valeurs
    de type word qui dfinissent les masques AND et XOR (ou la ligne de
    dpart et la ligne de fin s'il s'agit d'un curseur lectronique).
  VALEUR(S) PASSEE(S):
    L'indicateur boolen de nature du curseur, les 2 valeurs de type word
    pour les masques AND et XOR.
  VALEUR RETOURNEE:
    Aucune
  CONTROLE:
    Aucun (la validit des paramtres doit tre assur par l'appelant).
  VOIR AUSSI:
    Les fonctions mouse...
  PROGRAMME EXEMPLE:
    EXMOUSE.C
  ========================================================================*/
void mousecurtxt(boolean curelec, word masqueAND, word masqueXOR)
{
  union REGS inregs, outregs;

  inregs.x.ax = 0x000A;
  inregs.x.bx = curelec;
  inregs.x.cx = masqueAND;
  inregs.x.dx = masqueXOR;
  int86(0x33, &inregs, &outregs);
}
/*man=====================================================================
  mousegotoxy()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Positionne le curseur souris
  SYNTAXE:
    #include <wmmouse.h>
    void mousegotoxy(word pos_x, word pos_y)
  PROTOTYPE DANS:
    wmmouse.h
  DESCRIPTION:
    Analogue  la fonction gotoxy() du curseur texte mais appliqu au
    curseur souris.
  VALEUR(S) PASSEE(S):
    Les coordonnes x et y de l'cran
  VALEUR RETOURNEE:
    Aucune
  CONTROLE:
    Aucun
  VOIR AUSSI:
    Les fonctions mouse...
  PROGRAMME EXEMPLE:
    EXMOUSE.C
  ========================================================================*/
void mousegotoxy(word pos_x, word pos_y)
{
  union REGS inregs, outregs;

  inregs.x.ax = 0x0004;
  inregs.x.cx = (pos_x - 1) << 3;  /* << 3 quivaut  * 8 mais plus rapide */
  inregs.x.dx = (pos_y - 1) << 3;
  int86(0x33, &inregs, &outregs);
}

/*man=====================================================================
  mousehide()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Cache le curseur souris
  SYNTAXE:
    #include <wmmouse.h>
    void mousehide(void)
  PROTOTYPE DANS:
    wmmouse.h
  DESCRIPTION:
    Cache le curseur souris
  VALEUR(S) PASSEE(S):
    Aucune
  VALEUR RETOURNEE:
    Aucune
  CONTROLE:
    Aucun
  VOIR AUSSI:
    Les fonctions mouse...
  PROGRAMME EXEMPLE:
    EXMOUSE.C
  ========================================================================*/
void mousehide(void)
{
  union REGS inregs, outregs;

  inregs.x.ax = 0x0002;
  int86(0x33, &inregs, &outregs);
}

/*man=====================================================================
  mouseinstalled()
  ------------------------------------------------------------------------
  ACTION:
    Teste la prsence et initialise le driver souris
  SYNTAXE:
    #include <wmmouse.h>
    boolean mouseinstalled(void)
  PROTOTYPE DANS:
    wmmouse.h
  DESCRIPTION:
    Teste la prsence du driver souris, l'initialise ou le rinitialise.
    La variable globale mousebuttons contient alors le nombre de boutons
    actifs de la souris.
  VALEUR(S) PASSEE(S):
    Aucune
  VALEUR RETOURNEE:
    TRUE si le driver existe, FALSE sinon.
  CONTROLE:
    Aucun
  VOIR AUSSI:
    Les fonctions mouse...
  PROGRAMME EXEMPLE:
    EXMOUSE.C
  ========================================================================*/
boolean mouseinstalled(void)
{
  union REGS inregs, outregs;

  inregs.x.ax = 0x0000;
  int86(0x33, &inregs, &outregs);
  if (outregs.x.ax == 0xFFFF)
    mousebuttons = outregs.x.bx;
  return (outregs.x.ax == 0xFFFF) ? TRUE : FALSE;
}

/*man=====================================================================
  mouseshow()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Rend visible le curseur souris
  SYNTAXE:
    #include <wmmouse.h>
    void mouseshow(void)
  PROTOTYPE DANS:
    wmmouse.h
  DESCRIPTION:
    Rend visible le curseur souris cach par mousehide()
  VALEUR(S) PASSEE(S):
    Aucune
  VALEUR RETOURNEE:
    Aucune
  CONTROLE:
    Aucun
  VOIR AUSSI:
    Les fonctions mouse...
  PROGRAMME EXEMPLE:
    EXMOUSE.C
  ========================================================================*/
void mouseshow(void)
{
  union REGS inregs, outregs;

  inregs.x.ax = 0x0001;
  int86(0x33, &inregs, &outregs);
}

/*man=====================================================================
  mousestatus()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Renseigne sur l'tat de la souris
  SYNTAXE:
    #include <wmmouse.h>
    s_mouse mousestatus(void)
  PROTOTYPE DANS:
    wmmouse.h
  DESCRIPTION:
    Renseigne sur l'tat actuel de la souris en retournant une structure
    de type s_mouse (voir ce type dans WMMOUSE.H)
  VALEUR(S) PASSEE(S):
    Aucune
  VALEUR RETOURNEE:
    Une structure de type s_mouse
  CONTROLE:
    Aucun
  VOIR AUSSI:
    Les fonctions mouse...
  PROGRAMME EXEMPLE:
    EXMOUSE.C
  ========================================================================*/
s_mouse mousestatus(void)
{
  union REGS inregs, outregs;
  s_mouse S;

  inregs.x.ax = 0x0003;
  int86(0x33, &inregs, &outregs);
  S.leftbutton =  (outregs.x.bx & 1) ? TRUE : FALSE;
  S.rightbutton  = (outregs.x.bx & 2) ? TRUE : FALSE;
  S.centerbutton = (outregs.x.bx & 4) ? TRUE : FALSE;
  S.pos_x = (outregs.x.cx >> 3) + 1; /* transformation en position texte     */
  S.pos_y = (outregs.x.dx >> 3) + 1; /* >> 3 quivaut  / 8 mais plus rapide */
  return S;
}

/*man=====================================================================
  mousetype()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Renseigne sur le type du driver souris
  SYNTAXE:
    #include <wmmouse.h>
    t_mouse mousetype(void)
  PROTOTYPE DANS:
    wmmouse.h
  DESCRIPTION:
    Renseigne sur le type du driver souris en retournant une structure de
    type t_mouse (voir ce type dans WMMOUSE.H)
  VALEUR(S) PASSEE(S):
    Aucune
  VALEUR RETOURNEE:
    Une structure de type t_mouse
  CONTROLE:
    Aucun
  VOIR AUSSI:
    Les fonctions mouse...
  PROGRAMME EXEMPLE:
    EXMOUSE.C
  ========================================================================*/
t_mouse mousetype(void)
{
  union REGS inregs, outregs;
  t_mouse T;

  inregs.x.ax = 0x0024;
  int86(0x33, &inregs, &outregs);
  T.ver_maj = outregs.h.bh;
  T.ver_min = outregs.h.bl;
  T.type    = outregs.h.ch;
  T.numIRQ  = outregs.h.cl;
  return T;
}

/*man=====================================================================
  printcenter()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Affiche un texte centr sur une ligne
  SYNTAXE:
    #include <wmlib.h>
    void printcenter(char *text, byte line, byte color)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Affiche un texte centr sur une ligne de n caractres (n dpendant de
    la fentre active. 80 caractres par dfaut).
  VALEUR(S) PASSEE(S):
    Un pointeur sur le texte, le numro de ligne, l'attribut de couleur.
  VALEUR RETOURNEE:
    Aucune
  CONTROLE:
    Aucun
  VOIR AUSSI:

  PROGRAMME EXEMPLE:
    EXGETSTR.C
  ========================================================================*/
  void printcenter(char *text, byte line, byte color)
{
  byte attr_origine;
  int LargeurTotale;
  struct text_info info;

  gettextinfo(&info);              /* quel est l'attribut d'origine ?     */
  attr_origine = info.attribute;   /* ne pas perdre l'attribut de couleur */
  textattr(color);
  LargeurTotale =  info.winright - info.winleft + 1;
  gotoxy(round(LargeurTotale - (int)strlen(text), 2)+1, line);
  cputs(text);
  textattr(attr_origine);          /* restituer l'attribut sauvegard */
}
/*man=====================================================================
  round()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Valeur arrondie du quotient de 2 int
  SYNTAXE:
    #include <wmlib.h>
    int round(int a, int b)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Oublie dans la bibliothque standard C entre ceil() et floor(),
    la fonction round() est pourtant fort utile.
  VALEUR(S) PASSEE(S):
    le nombre et le diviseur (tous deux de type int)
  VALEUR RETOURNEE:
    le quotient arrondi (de type int)
  CONTROLE:
    Aucun
  VOIR AUSSI:
    lround()
  PROGRAMME EXEMPLE:

  ========================================================================*/
int round(int a, int b)
{
  div_t x;

  x = div(a, b);
  return( (x.rem > ((float)b/2)) ? ++(x.quot) : x.quot);
}

/*man=====================================================================
  lround()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Valeur arrondie du quotient de 2 int
  SYNTAXE:
    #include <wmlib.h>
    long lround(long a, long b)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Oublie dans la bibliothque standard C entre ceil() et floor(),
    la fonction lround() est pourtant fort utile.
  VALEUR(S) PASSEE(S):
    le nombre et le diviseur (tous deux de type long int)
  VALEUR RETOURNEE:
    le quotient arrondi (de type long int)
  CONTROLE:
    Aucun
  VOIR AUSSI:
    round()
  PROGRAMME EXEMPLE:

  ========================================================================*/
long lround(long int a, long int b)
{
  ldiv_t x;

  x = ldiv(a, b);
  return( (x.rem > ((double)b/2)) ? ++(x.quot) : x.quot);
}
/*========================================================================
  affiche_cadre_blanc()    fonction prive
  ------------------------------------------------------------------------
  EFFET:
    affiche un cadre blanc autour de la couleur prslectionne
  SYNTAXE:
    #include <wmlib.h>
    void affiche_cadre_blanc(byte sel_x, byte sel_y)
    NE PAS UTILISER CETTE FONCTION
  DESCRIPTION:
    fonction interne. Affiche un cadre blanc autour de la couleur prs-
    lectionne. Paramtres passs: x et y de type byte.
  VALEUR RETOURNEE:
    Aucune.
  CONTROLE:
    Aucun controle
  ========================================================================*/
static void affiche_cadre_blanc(byte sel_x, byte sel_y)
{
  dputch(sel_x - 2, sel_y - 1, WHITE, 218);
  dputch(sel_x - 1, sel_y - 1, WHITE, 196);
  dputch(sel_x    , sel_y - 1, WHITE, 196);
  dputch(sel_x + 1, sel_y - 1, WHITE, 196);
  dputch(sel_x + 2, sel_y - 1, WHITE, 191);

  dputch(sel_x - 2, sel_y    , WHITE, 179);
  dputch(sel_x + 2, sel_y    , WHITE, 179);

  dputch(sel_x - 2, sel_y + 1, WHITE, 192);
  dputch(sel_x - 1, sel_y + 1, WHITE, 196);
  dputch(sel_x    , sel_y + 1, WHITE, 196);
  dputch(sel_x + 1, sel_y + 1, WHITE, 196);
  dputch(sel_x + 2, sel_y + 1, WHITE, 217);
}

/*========================================================================
  efface_cadre_blanc()    fonction prive
  ------------------------------------------------------------------------
  EFFET:
    Efface le cadre blanc existant.
  SYNTAXE:
    #include <wmlib.h>
    void efface_cadre_blanc(byte sel_x, byte sel_y, byte l_coultext)
    NE PAS UTILISER CETTE FONCTION
  DESCRIPTION:
    Efface le cadre blanc de prslection de couleurs en reconstituant
    les 'x' l o il faut. Paramtres passs: x et y ainsi que la
    couleur de texte de type byte.
  VALEUR RETOURNEE:
    Aucune.
  CONTROLE:
    Aucun controle.
  ========================================================================*/
static void efface_cadre_blanc(byte sel_x, byte sel_y, byte l_coultext)
{
  dputch(sel_x - 2, sel_y - 1, 00, 00);  /* la couleur texte n'a aucune     */
  dputch(sel_x - 1, sel_y - 1, 00, 00);  /* importance sauf quand il s'agit */
  if (l_coultext == 0)                   /* de remettre les 'x'             */
    dputch(sel_x    , sel_y - 1, 00, 00);
  else
    dputch(sel_x    , sel_y - 1, l_coultext-1, 120);
  dputch(sel_x + 1, sel_y - 1, 00, 00);
  dputch(sel_x + 2, sel_y - 1, 00, 00);

  dputch(sel_x - 2, sel_y    , 00, 00);
  dputch(sel_x + 2, sel_y    , 00, 00);

  dputch(sel_x - 2, sel_y + 1, 00, 00);
  dputch(sel_x - 1, sel_y + 1, 00, 00);
  if (l_coultext == 15)
    dputch(sel_x    , sel_y + 1, 00, 00);
  else
    dputch(sel_x    , sel_y + 1, l_coultext+1, 120);
  dputch(sel_x + 1, sel_y + 1, 00, 00);
  dputch(sel_x + 2, sel_y + 1, 00, 00);
}

/*man=====================================================================
  selectcolor()
  ------------------------------------------------------------------------
  ACTION:
    Slection de couleurs de texte et de fond
  SYNTAXE:
    #include <wmlib.h>
    void selectcolor(int x, int y, byte *coultext, byte*coulfond)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Permet  l'utilisateur de slectionner les couleurs de texte et de fond
    dans une fentre texte analogue  celle de TCINST de TC 2.0. Les valeurs
    modifiables prdfinies sont passes. Le dplacement dans la fentre
    se fait avec les touches curseur, la sortie avec modification des valeurs
    par ENTER, sans modification par ESC.
  VALEUR(S) PASSEE(S):
    les coordonnes du coin suprieur gauche de la fentre, les adresses
    des variables couleur texte et fond contenant leur valeur prdfinie.
    Le contenu de ces variables seront ventuellement modifie par la fonction.
  VALEUR RETOURNEE:
    Aucune
  CONTROLE:
    Les coordonnes admissibles de la fentre ainsi que la validit des
    couleurs prdfinies passes.
  VOIR AUSSI:

  PROGRAMME EXEMPLE:
    EXSELCOL.C
  ========================================================================*/
void selectcolor(int x, int y, byte *coultext, byte *coulfond)
{
  int i, j;                     /* compteurs d'itrations */
  int x2, y2;                   /* coordonnes manquantes */
  int sel_x, sel_y;             /* valeurs x et y  usage local */
  int surface;                  /* taille se la surface cran  sauvegarder */
  void *ptrbuf;                 /* pointeur sur zone tampon */
  byte l_coulfond = *coulfond;  /* transfert dans des variables locales */
  byte l_coultext = *coultext;  /* idem */
  byte carclav, codclav;        /* code ASCII et code clavier */
  byte attribut_origine;        /* sauvegarde attribut */
  struct text_info info;        /* structure video texte */

    /* vrification du domaine de validit des paramtres */
  if ( (x > 53) || (x < 1) || (y > 6) || (y < 1) || (*coultext > 15) ||
    (*coulfond > 7) )
  {
    drelin();
    fputs("Erreur de paramtres dans la fonction selectcolor", stderr);
    exit(0);
  }

    /* sauvegarde de l'attribut couleur d'origine */
  gettextinfo(&info);
  attribut_origine = info.attribute;

  hidecursor();    /* cachez ce curseur... */

    /* Calcul des coordonnes manquantes de la fentre */
  x2 = x + 1 + (3*8) + 2;
  y2 = y + 1 + 16 + 2;

    /* Calcul et sauvegarde de la surface cran pralable */
  surface = (x2-x)*(y2-y)*(sizeof(word));
  if ((ptrbuf = getmem(surface)) == NULL) exit(0);
  gettext(x, y, x2, y2, ptrbuf);

    /* mise en fond noir de la fentre */
  window(x, y, x2, y2);
  textbackground(BLACK);
  clrscr();
  window(1, 1, 80, 25);

    /* trac du cadre et du bandeau */
  frame(x, y, x2, y2, 1, LIGHTRED, BLACK, FALSE, FALSE);

    /* Affichage de la mosaque des couleurs */
  for (j = 0; j <= 15; j++)
  {
    gotoxy(x+2, y+2 + j);
    for (i = 0; i <= 7; i++)
    {
      textbackground(i);
      textcolor(j);
      cputs(" x ");
    }
  }

    /* trac du cadre blanc autour de la couleur slectionne */
  sel_x = x + 3 + (l_coulfond * 3);
  sel_y = y + 2 + l_coultext;

    /* affiche la prslection d'origine */
  affiche_cadre_blanc(sel_x, sel_y);

    /* boucle d'affichage des slections */
  do
  {
    carclav = codclav = 0;                /* mise  zro */
    carclav = getch();                    /* saisie d'une touche */
    if (carclav == 0) codclav = getch();  /* si non ASCII alors code clavier */
    efface_cadre_blanc(sel_x, sel_y, l_coultext);

    if (codclav == 0x50)                     /* flche basse */
      if (l_coultext < 15) l_coultext++;

    if (codclav == 0x48)                     /* flche haute */
      if (l_coultext > 0) l_coultext--;

    if (codclav == 0x4D)                     /* flche droite */
      if (l_coulfond < 7) l_coulfond++;

    if (codclav == 0x4B)                     /* flche gauche */
      if (l_coulfond > 0) l_coulfond--;

    sel_x = x + 3 + (l_coulfond * 3);        /* recalcul de la pos. de 'x'   */
    sel_y = y + 2 + l_coultext;              /* relativement aux couleurs    */
    affiche_cadre_blanc(sel_x, sel_y);       /* affichage nouvelle slection */

  } while ( !((carclav == 0x0D) || (carclav == 0x1B))); /* 2 cas de sortie */

    /* Affectation des couleurs modifies aux variables de retour si la
       touche ENTREE a t appuye. Pas d'affectation si c'est la touche
       ESC                                                                */
  if (carclav == 0x0D)
  {
    *coultext = l_coultext;
    *coulfond = l_coulfond;
  }

    /* reconstitution de la surface d'cran pralable, dsallocation
       mmoire, restitution du curseur et d'attribut                  */
  puttext(x, y, x2, y2, ptrbuf);
  free(ptrbuf);
  showcursor();
  textattr(attribut_origine);
}
/*man=====================================================================
    strdtime()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    retourne une chane  partir de la structure dtime
  SYNTAXE:
    #include <wmlib.h>
    char *strdtime(struct dtime *_dt)
  PROTOTYPE DANS
    wmlib.h
  DESCRIPTION:
    Confectionne une chane date-temps prcd du nom du jour  partir
    d'une structure dtime.
  VALEUR(S) PASSEE(S):
    Un pointeur sur la structure dtime.
  VALEUR RETOURNEE:
    Une chane.
  CONTROLE:
    Aucun
  VOIR AUSSI
    getstrdate(), getstrtime(), ctrldate(), getdtimesys()
  PROGRAMME EXEMPLE:
    EXDTEMPS.C
  ========================================================================*/
char *strdtime(struct dtime *_dt)
{
  static char StrDt[24];       /* la chane  retourner */
  char date[11];                /* une chane date d'usage local */
  word j, m, a;

    /* Met la date sous forme d'une chane JJ/MM/AAAA  partir de _dt */
  sprintf(date, "%02d/%02d/%04d", _dt->dt_jour, _dt->dt_mois, _dt->dt_annee);

    /* Rcupre le nom du jour et confectionne la chane date-temps complte */
  sprintf(StrDt, "%s %s %02d:%02d:%02d", nom_jour[ctrldate(date, &j, &m, &a)], date,
    _dt->dt_heure, _dt->dt_minute, _dt->dt_seconde);
  return StrDt;
}
/*man=====================================================================
  toupperfr()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Remplace toupper() pour les minuscules franaises
  SYNTAXE:
    #include <wmlib.h>
    unsigned char toupperfr(unsigned char c)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Utile pour les froggies: nos petites misres nationales sont transformes
    aussi en majuscules (ce que ne fait pas toupper() limit  l'ASCII 7 bits)
  VALEUR(S) PASSEE(S):
    Le caractre minuscule
  VALEUR RETOURNEE:
    Le caractre majusculis
  CONTROLE:
    Aucun (si la minuscule n'est pas majusculable elle est retourne sans
    changement comme le fait toupper() )
  VOIR AUSSI:
    getstr()
  PROGRAMME EXEMPLE:

  ========================================================================*/
unsigned char toupperfr (unsigned char c)
{
  if (c <= 122 && c >= 97)        /* si on est dans le domaine ASCII */
    c -= 32;                      /* on retire 32 et le tour est jou */
  else                            /* sinon */
    switch (c)                    /* il faut passer la revue de dtail */
    {
      case 129 : c = 'U'; break;  /* il suffit d'adapter le mme canevas */
      case 130 : c = 'E'; break;  /* pour les alphabets allemands, espagnols */
      case 131 : c = 'A'; break;  /* ou nordiques */
      case 133 : c = 'A'; break;
      case 135 : c = 'C'; break;
      case 136 : c = 'E'; break;
      case 137 : c = 'E'; break;
      case 138 : c = 'E'; break;
      case 139 : c = 'I'; break;
      case 140 : c = 'I'; break;
      case 147 : c = 'O'; break;
      case 148 : c = 'O'; break;
      case 150 : c = 'U'; break;
      case 151 : c = 'U'; break;
  }
  return (c);
}  

#pragma startup wmlibinit       /* cette fonction est xcute au dmarrage */

/*man=====================================================================
  wmlibinit()  fonction globale non utilisateur lance par #pragma startup
  ------------------------------------------------------------------------
  ACTION:
    Initialise les variables globales video
  SYNTAXE:
    #include <wmlib.h>
    void wmlibinit(void)
  PROTOTYPE DANS:
    wmlib.h
  DESCRIPTION:
    Dtecte les valeurs du BIOS video et les range dans videocard (type
    byte), colorcard (type boolean), videoseg (type word) et info_text
    (type struct text_info). Voir les dfinitions de ces variables globales
    dans WMLIB.H.
    Cette fonction n'a pas a tre utilise explicitement elle est lance
    automatiquement par la directive #pragma startup au dbut de tout programme
    utilisant la librairie.
  VALEUR(S) PASSEE(S):
    Aucune
  VALEUR RETOURNEE:
    Aucune
  CONTROLE:
    Aucun
  VOIR AUSSI:

  PROGRAMME EXEMPLE:
    EXWMINIT.C
  ========================================================================*/
void wmlibinit(void)
{
  union REGS inregs, outregs;

  videocard   = 0xFF;              /* initialisation  une valeur inutilise */
  inregs.h.ah = 0x1A;              /* int 0x10 fnc 0x1A BIOS VGA ? */
  inregs.h.al = 0;
  int86(0x10, &inregs, &outregs);
  if (outregs.h.al == 0x1A)        /* BIOS VGA ? */
  {                                /* Oui */
    videocard = outregs.h.bl;
    colorcard = ( (videocard == 1) || (videocard == 5) ||
      (videocard == 7) ) ? FALSE : TRUE ;
  }
  else                             /* Non */
  {
    inregs.h.ah = 0x12;            /* int 0x10 fnc 0x12 s/fnc 0x10 EGA/VGA ? */
    inregs.h.bl = 0x10;
    inregs.h.al = 0;
    int86(0x10, &inregs, &outregs);
    if (outregs.h.bl != 0x10)
    {
      videocard = (outregs.h.cl == 0x0B) ? 5 : 4;
      colorcard = (outregs.h.cl == 0x0B) ? FALSE : TRUE;
    }
  }
  gettextinfo(&info_text);
  videoseg = (info_text.currmode == 7) ? 0xB000: 0xB800;
  if (videocard == 0xFF)
  {
    videocard = (info_text.currmode == 7) ? 1 : 2;
    colorcard = ( (info_text.currmode == 0) || (info_text.currmode == 2) ||
      (info_text.currmode == 7) ) ? FALSE : TRUE;
  }
}
/*man=====================================================================
  openwindow()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Dfinit et ouvre une fentre
  SYNTAXE:
    #include <wmlib.h>
    struct windowdef *openwindow(int x1, int y1, int x2, int y2,
      int bordertype, int bordercolor, int windowcolor, const char *banner)
  PROTOTYPE DANS:
    wmwind.h
  DESCRIPTION:
    La fentre est dfinie par ses paramtres et devient oprationnelle.
  VALEUR(S) PASSEE(S):
    Les coordonnes: x1, y1, x2, y2, le type de frame, la couleur et le texte
    du bandeau
  VALEUR RETOURNEE:
    Retourne un pointeur de structure windowdef, NULL en cas d'insuccs.
  CONTROLE:
    Contrle les erreurs de paramtres (coordonnes, type de cadre, couleurs)
    ainsi que la mmoire alloue  la structure et  la portion d'cran
    sauvegarde.
  VOIR AUSSI:
    closewindow, hidewindow(), showwindow(), movewindow()
  PROGRAMME EXEMPLE:
    EXWMWIND.C
  ========================================================================*/
struct windowdef *openwindow(int x1, int y1, int x2, int y2, int bordertype,
  int bordercolor, int windowcolor, boolean shadow, const char *banner)
{
  int temp;
  struct text_info info;
  struct windowdef *w;   /* structure de la fentre  construire */

  gettextinfo(&info);    /* lit les caractristiques video en cours */

    /* teste si pas d'erreurs de paramtres */
  if (!shadow)
  {
    if ( (x1 < 1 || x1 > x2 || x2 > info.screenwidth)	  ||
       (y1 < 1 || y1 > y2 || y2 > info.screenheight)	  ||
       (bordertype > MAXBORDER || bordertype < NOBORDER) ||
       (bordercolor > 255 || windowcolor > 255) ) return NULL;
  }
  else
    if ( (x1 < 1 || x1 > x2 || x2+2 > info.screenwidth)	  ||
       (y1 < 1 || y1 > y2 || y2+1 > info.screenheight)	  ||
       (bordertype > MAXBORDER || bordertype < NOBORDER) ||
       (bordercolor > 255 || windowcolor > 255) ) return NULL;

  if ( (w = (struct windowdef *)getmem(sizeof(struct windowdef))) == NULL)
    return w;
    /* teste s'il y a de la mmoire  allouer  la structure */

  if (!shadow)
    w->savearealen = temp = (x2 - x1 + 1) * (y2 - y1 + 1) * 2;
  else
    w->savearealen = temp = (x2 - x1 + 3) * (y2 - y1 + 2) * 2;
    /* dtermine le nombre d'octets de la portion cran  sauvegarder */

  if ((w->savearea = getmem(temp)) == NULL) /* si pas de mmoire pour */
  {                                         /* la sauvegarde          */
    free(w);       /* libre la place alloue  la structure */
    return NULL;   /* et retourne NULL */
  }

  if (!shadow)
    gettext(x1, y1, x2, y2, w->savearea);  /* sauvegarde la portion cran */
  else
    gettext(x1, y1, x2+2, y2+1, w->savearea);

  w->x1 = x1;    /* affecte les paramtres transmis aux variables struct. */
  w->y1 = y1;
  w->x2 = x2;
  w->y2 = y2;
  w->bordercolor = bordercolor;
  w->windowcolor = windowcolor;
  w->shadow      = shadow;

  if (bordertype == NOBORDER) w->border = FALSE;  /* pas de bordure? */
  else                                            /* si, alors...    */
  {
    w->border = TRUE;                             /* indicateur positionn */

      /* trac du frame avec ou sans ombrage */
    if (!shadow)
      frame(x1, y1, x2, y2, bordertype, bordercolor & 0x0F,
        (bordercolor & 0xF0) >> 4, FALSE, FALSE);
    else
      frame(x1, y1, x2, y2, bordertype, coultext(bordercolor),
        coulfond(bordercolor), TRUE, FALSE);

      /* Ecriture du bandeau */
    if ((temp = strlen(banner)) != 0)
    {
      char dest[81] = "";               /* variable chane */
      window(1, 1, 80, 25);             /* revenir  l'cran standard    */
      strncpy (dest, banner, x2 - x1 - 3);  /* ne copier que ce qui tient */
      gotoxy((x2+x1-strlen(dest))/2+1, y1);  /* calculer la pos. d'affichage */
      textattr(bordercolor);            /* afficher, dans sa couleur...  */
      cprintf(dest);                    /* ... le texte du bandeau       */
    }
  }

  _DX = w->border;                      /* _DX vaut 1 si cadre, 0 sinon */
  window(x1 + _DX, y1 + _DX, x2 - _DX, y2 - _DX);
    /* dfinition de la fentre  l'intrieur du cadre ventuel */
  textattr(windowcolor);
  clrscr();                  /* initialisation de la fentre avec sa couleur */

  w->nextwind = NULL;        /* pas de fentre suivante pour w */
  w->prevwind = activewind;  /* la fen. prcd. de w est la fen. active */
  activewind->nextwind = w;  /* la fen. active a pour suivante w */
  activewind->windowcolor = info.attribute;  /* conservation de l'attribut */

  w->prevx = info.curx;   /* conservation de la pos. antrieure du curseur */
  w->prevy = info.cury;

  w->state = OPEN;        /* statut de w */

  return activewind = w;  /* w devient la fen. active avec retour du point. */
}

/*========================================================================
  swapwindow()    fonction prive
  ------------------------------------------------------------------------
  EFFET:
    change de fentre
  SYNTAXE:
    #include <wmlib.h>
    static int swapwindow(struct windowdef *w)
    NE PAS UTILISER CETTE FONCTION
  DESCRIPTION:
    La fentre est change avec la prcdente.
    Paramtre pass: la fentre. 
  VALEUR RETOURNEE:
    Retourne TRUE en cas de succs, FALSE autrement.
  CONTROLE:
    Retourne FALSE si la fentre n'existe pas ou si elle est ouverte mais
    non active. Retourne FALSE s'il n'y a pas assez de mmoire pour le
    tampon provisoire.
  ========================================================================*/
static boolean swapwindow(struct windowdef *w)
{
  int  size;
  void *temp;             /* pointeur atypique */
  struct text_info info;

  if (!w || (w->state == OPEN && w != activewind)) return FALSE;
    /* si fentre inexistante, ouverte et non active */

  if ((temp = getmem(size = w->savearealen)) == NULL) return FALSE;
    /* si pas de place en mmoire pour la portion d'cran */

  gettextinfo(&info);  /* rcupration des valeurs video */
  if (!(w->shadow))
    gettext(w->x1, w->y1, w->x2, w->y2, temp);
  else
    gettext(w->x1, w->y1, w->x2+2, w->y2+1, temp);

    /* sauvegarde de la portion d'cran */
  if (!(w->shadow))
    puttext(w->x1, w->y1, w->x2, w->y2, w->savearea);
  else
    puttext(w->x1, w->y1, w->x2+2, w->y2+1, w->savearea);

    /* affichage de la portion d'cran sauvegarde pralablement */
  movmem(temp, w->savearea, size);
    /* MAJ nouvelle sauvegarde */

  if (w->state == HIDDEN)    /* si fentre cache... */
  {
    w->state = OPEN;         /* devient ouverte */
    w->prevwind->nextwind = w->nextwind;
      /* la prcdente a pour suivante la suivante de w (on saute donc w
         dans la liste chane) */

    if (w->nextwind) w->nextwind->prevwind = w->prevwind;
      /* si elle existe la suivante a pour prcdente la prcdente de w
         (mme remarque concernant w) */

    w->nextwind = activewind->nextwind;
      /* la suivante de w est la suivante de l'active */

    w->prevwind = activewind;
      /* la prcdente de w est l'active */

    activewind->nextwind = w;
      /* la suivante de l'active est w */

    activewind = w;  /* l'active devient w */
  }
  else                        /* si elle n'est pas cache... */
  {
    w->state = HIDDEN;          /* elle le devient */
    activewind = w->prevwind;   /* et la fen. active est la prcdente */
    w->windowcolor = info.attribute;  /* en rcuprant l'attribut en cours */
  }

  _DX = activewind->border;   /* re-dfinition de la fentre en tenant compte
                                 de la bordure */
  window(activewind->x1 + _DX, activewind->y1 + _DX,
         activewind->x2 - _DX, activewind->y2 - _DX);
  textattr(activewind->windowcolor);

  gotoxy(w->prevx, w->prevy);
    /* positionnement du curseur  la pos. conserve */

  w->prevx = info.curx;  /* sauvegarde de la nouvelle position curseur */
  w->prevy = info.cury;  /* dans w (la fentre cache) */

  free(temp);  /* rcup. de la portion de mmoire utilise temporairement */

  return TRUE;  /* tout s'est bien pass */
}

/*man=====================================================================
  hidewindow()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Cache la fentre
  SYNTAXE:
    #include <wmwind.h>
    boolean hidewindow(struct windowdef *w)
  PROTOTYPE DANS:
    wmwind.h
  DESCRIPTION:
    Rend invisible la fentre active (et seulement elle) en restituant la
    portion cran qu'elle recouvrait.
  VALEUR(S) PASSEE(S):
    Un pointeur sur la fentre
  VALEUR RETOURNEE:
    TRUE si tout est correct, FALSE si l'opration est impossible.
  CONTROLE:
    La validit de la fentre et la disponibilit mmoire pour l'opration.
  VOIR AUSSI:
    showwindow(), movewindow(), closewindow(), openwindow()
  PROGRAMME EXEMPLE:
    EXWMWIND.C
  ========================================================================*/
boolean hidewindow(struct windowdef *w)
{
  if (w->state != OPEN) return FALSE;
  return swapwindow(w);
}

/*man=====================================================================
    showwindow()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Montre la fentre
  SYNTAXE:
    #include <wmwind.h>
    boolean showwindow(struct windowdef *w)
  PROTOTYPE DANS:
    wmwind.h
  DESCRIPTION:
    Montre la fentre pralablement cache par hidewindow()
  VALEUR(S) PASSEE(S):
    Un pointeur sur la stucture de la fentre
  VALEUR RETOURNEE:
    TRUE si l'opration a russie, FALSE sinon
  CONTROLE:
    Vrifie l'tat HIDDEN de la fentre.
  VOIR AUSSI:
    hidewindow(), movewindow(), openwindow(), closewindow()
  PROGRAMME EXEMPLE:
    EXWMWIND.C
  ========================================================================*/
boolean showwindow(struct windowdef *w)
{
  if (w->state != HIDDEN) return FALSE;
  return swapwindow(w);
}

/*man=====================================================================
  movewindow()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Dplace la fentre active
  SYNTAXE:
    #include <wmwind.h>
    boolean movewindow(struct windowdef *w, int x, int y)
  PROTOTYPE DANS:
    wmwind.h
  DESCRIPTION:
    Dplace la fentre active aux nouvelles coordonnes.
  VALEUR(S) PASSEE(S):
    Un pointeur sur la structure fentre, les coordonnes x et y du nouveau
    coin suprieur gauche.
  VALEUR RETOURNEE:
    TRUE si tout est correct, FALSE si problme avec la fentre et/ou
    la mmoire
  CONTROLE:
    La validit de la fentre et l'allocation mmoire
  VOIR AUSSI:
    openwindow(), hidewindow(), showwindow(), closewindow()
  PROGRAMME EXEMPLE:
    EXWMWIND.C
  ========================================================================*/
boolean movewindow(struct windowdef *w, int x, int y)
{
  struct text_info info;

  if (!w) return FALSE;     /* teste si la fentre existe */

  gettextinfo(&info);
  if ( (x + (w->x2 - w->x1) > info_text.screenwidth)	||
       (y + (w->y2 - w->y1) > info_text.screenheight) ) return FALSE;
    /* teste les dpassements d'cran */

  if (!hidewindow(w)) return FALSE;
    /* cache la fentre retourne FALSE en cas d'chec */

  w->x2 += x - w->x1;  /* actualise les coordonnes dans les variables */
  w->y2 += y - w->y1;  /* de la structure w                            */
  w->x1 = x;
  w->y1 = y;

  return showwindow(w);  /* change la fentre */
}

/*man=====================================================================
  closewindow()  fonction utilisateur
  ------------------------------------------------------------------------
  ACTION:
    Ferme la fentre
  SYNTAXE:
    #include <wmwind.h>
    boolean closewindow(struct windowdef *w)
  PROTOTYPE DANS:
    wmwind.h
  DESCRIPTION:
    Ferme la fentre pass en paramtre. La mmoire alloue pour la structure
    est libre ainsi que la portion d'cran. ATTENTION! La fentre doit tre
    active pour pouvoir tre ferme!
  VALEUR(S) PASSEE(S):
    Un pointeur sur la structure fentre.
  VALEUR RETOURNEE:
    Retourne TRUE en cas de succs.
  CONTROLE:
    Contrle la validit de l'opration de cache avant de librer la mmoire.
  VOIR AUSSI:
    openwindow(), movewindow(), hidewindow()
  PROGRAMME EXEMPLE:
    EXWMWIND.C
  ========================================================================*/
boolean closewindow(struct windowdef *w)
{
  boolean ret;

  if ((ret = hidewindow(w)) == TRUE)  /* cache la fentre (en restituant) */
  {                                   /* la portion cran                 */
    free(w->savearea);  /* rcupre la mmoire de la portion d'cran */
    free(w);            /* et celle occupe par la structure w       */
  }
  return ret;
}

