/*
----------------------------------------------------
  Module   : FICHIER.C
			      Turbo C++

  Auteur   : Jean-Philippe BOCQUENET

  Date     : 25/X/1993

  Objet    : Lecture des repertoires et fichiers.

----------------------------------------------------
*/


#include <alloc.h>
#include "wmmouse.h"
#include "wmwind.h"
#include "wmlib.h"
#include "defini.h"

#define 	XWIN    43
#define 	YWIN     2

sdrive **liste_drive;
char **liste_fich;            /* pointeur de pointeurs de char */
char **liste_rep;             /* pointeur de pointeurs de char */
int nbfichiers = 0;           /* nombre de fichiers */
int nbrepertoires = 0;        /* nombre de rpertoires */
int i;                        /* compteur annexe */
char nom_fichier[15];
int tableau_mouse[YWIN+23][XWIN+35];

/*
----------------------------------------------------
  Fonction : BOUTON
 Affiche un petit rectangle de 4 caracteres sur 2.
----------------------------------------------------
*/
void bouton(int xbout,int ybout,char *touch, char *texte, int tabl)
{
int x,y;

  for(x=xbout;x<=xbout+4;x++)
  {
   for(y=ybout;y<=ybout+2;y++)
   {
    tableau_mouse[y][x]=tabl;
   }
  }
  frame(xbout,ybout,xbout+4,ybout+2,SINGLEBORDER,MAGENTA,CYAN,FALSE,TRUE);
  gotoxy(xbout,ybout+1); printf(touch);
  textbackground(WHITE); textcolor(BLACK);
  gotoxy(xbout,ybout+3); cprintf(texte);
}

/*
----------------------------------------------------
  Fonction : MASQUE_SAISIE
----------------------------------------------------
*/
void masque_saisie()
{
int x,y;
int bou,tampaff;

   liste_drive = mklstsdrive(); maxdrive-=1;
   liste_rep   = mklstfile("*.*", FA_DIREC, &nbrepertoires);
   liste_fich  = mklstfile("*.*", 0x21,     &nbfichiers);

  dputs(XWIN+4, YWIN+1,BLACK, "Fichier :");
  frame(XWIN+4, YWIN+2,XWIN+31, YWIN+2, SPACEBORDER, CYAN, BLUE, FALSE, TRUE);
  for(x=XWIN+4;x<=XWIN+31;x++)
  {
   for(y=YWIN+2;y<=YWIN+2;y++)
   {
    tableau_mouse[y][x]=1;
   }
  }

/*
  frame(XWIN+3, YWIN+4,XWIN+16, YWIN+7, SINGLEBORDER, LIGHTGRAY,BLUE, TRUE, TRUE);
  dputs(XWIN+4, YWIN+4,WHITE,"Lect");
  for(x=XWIN+3;x<=XWIN+16;x++)
  {
   for(y=YWIN+4;y<=YWIN+7:y++)
   {
    tableau_mouse[y][x]=2;
   }
  }

*/
  frame(XWIN+3,YWIN+9,XWIN+16,YWIN+17, SINGLEBORDER, LIGHTGRAY,BLUE, TRUE, TRUE);
  dputs(XWIN+4,YWIN+9,WHITE,"Rp.");
  for(x=XWIN+3;x<=XWIN+16;x++)
  {
   for(y=YWIN+9;y<=YWIN+17;y++)
   {
    tableau_mouse[y][x]=3;
   }
  }

  frame(XWIN+19, YWIN+4,XWIN+32,YWIN+17, SINGLEBORDER, LIGHTGRAY,BLUE, TRUE, TRUE);
  dputs(XWIN+20, YWIN+4,WHITE,"Fich");
  for(x=XWIN+19;x<=XWIN+32;x++)
  {
   for(y=YWIN+4;y<=YWIN+17;y++)
   {
    tableau_mouse[y][x]=4;
   }
  }

  bouton(XWIN+4, YWIN+19,"TAB","WINDO",5);
  bouton(XWIN+10,YWIN+19,"  ","HAUT.",6);
  bouton(XWIN+16,YWIN+19,"  "," BAS ",7);
  bouton(XWIN+22,YWIN+19,"ESC","ABAND",8);
  bouton(XWIN+28,YWIN+19,"ENTER","OPEN.",9);

/*
  if (maxdrive >= 1) {tampaff = 1;}
  else {tampaff = maxdrive;}
  for(bou=0;bou <= tampaff;bou++)
   {
     gotoxy(XWIN+4,YWIN+5+bou);
     printf("%c\n",bou+'A');
     gotoxy(XWIN+9,YWIN+5+bou);
     switch(liste_drive[bou]->nature)
     {
      case FICTIF : printf("Fictif \n"); break;
      case NORMAL : printf("Normal \n"); break;
      case NETWORK: printf("Network\n"); break;
      case RAMDISK: printf("Ramdisk\n"); break;
     }
   }
*/

  if (nbrepertoires >= 6) {tampaff = 6;}
  else {tampaff = nbrepertoires;}
  for(bou=0;bou <= tampaff;bou++)
   {
     gotoxy(XWIN+4,YWIN+10+bou);
     printf("%s\n",liste_rep[bou]);
   }

  if (nbfichiers >= 11) {tampaff = 11;}
  else {tampaff = nbfichiers;}
  for(bou=0;bou <= tampaff;bou++)
   {
     gotoxy(XWIN+20,YWIN+5+bou);
     printf("%s\n",liste_fich[bou]);
   }
}

/*
----------------------------------------------------
  Fonction : AFFICHE_LECT
----------------------------------------------------
*/
int affiche_lect()
{
  unsigned int touche;
  int x = 0; int xt = 0;
  int tampaff;
  int bou;
  char nom_lecteur[5];

  for(;;)
  {
    if (maxdrive >= 1) {tampaff = 1;}
    else {tampaff = maxdrive;}
    for(bou=0;bou <= tampaff;bou++)
    {
     textbackground(BLUE); textcolor(LIGHTGRAY);
     gotoxy(XWIN+4,YWIN+5+bou);
     cprintf("            ");
     gotoxy(XWIN+4,YWIN+5+bou);
     cprintf("%c\n",bou+x+'A');
     gotoxy(XWIN+9,YWIN+5+bou);
     switch(liste_drive[bou+x]->nature)
     {
      case FICTIF : cprintf("Fictif \n"); break;
      case NORMAL : cprintf("Normal \n"); break;
      case NETWORK: cprintf("Network\n"); break;
      case RAMDISK: cprintf("Ramdisk\n"); break;
     }
      textbackground(GREEN); textcolor(WHITE);
      gotoxy(XWIN+4,YWIN+5+xt);
      cprintf("            ");
      gotoxy(XWIN+4,YWIN+5+xt);
      cprintf("%c\n",x+xt+'A');
      gotoxy(XWIN+9,YWIN+5+xt);
      switch(liste_drive[xt+x]->nature)
      {
       case FICTIF : cprintf("Fictif \n"); break;
       case NORMAL : cprintf("Normal \n"); break;
       case NETWORK: cprintf("Network\n"); break;
       case RAMDISK: cprintf("Ramdisk\n"); break;
      }
    }
    touche=bioskey(0);
    switch(touche)
    {
      case ENTER:    textbackground(BLUE); textcolor(LIGHTGRAY);
		     gotoxy(XWIN+4,YWIN+5+xt);
		     cprintf("            ");
		     gotoxy(XWIN+4,YWIN+5+xt);
		     cprintf("%c\n",x+xt+'A');
		     gotoxy(XWIN+9,YWIN+5+xt);
		     switch(liste_drive[xt+x]->nature)
		     {
		      case FICTIF : cprintf("Fictif \n"); break;
		      case NORMAL : cprintf("Normal \n"); break;
		      case NETWORK: cprintf("Network\n"); break;
		      case RAMDISK: cprintf("Ramdisk\n"); break;
		     }
		     strcpy(nom_lecteur," ");
		     *nom_lecteur='A'+xt+x;
		     strcat(nom_lecteur,":\\");
		     chdir(nom_lecteur);
		     masque_saisie();
		     return 2;

      case ESC:      return 10;

      case TAB:      textbackground(BLUE); textcolor(LIGHTGRAY);
		     gotoxy(XWIN+4,YWIN+5+xt);
		     cprintf("            ");
		     gotoxy(XWIN+4,YWIN+5+xt);
		     cprintf("%c\n",x+xt+'A');
		     gotoxy(XWIN+9,YWIN+5+xt);
		     switch(liste_drive[xt+x]->nature)
		     {
		      case FICTIF : cprintf("Fictif \n"); break;
		      case NORMAL : cprintf("Normal \n"); break;
		      case NETWORK: cprintf("Network\n"); break;
		      case RAMDISK: cprintf("Ramdisk\n"); break;
		     }
		     return 3;

      case FL_DROITE:textbackground(BLUE); textcolor(LIGHTGRAY);
		     gotoxy(XWIN+4,YWIN+5+xt);
		     cprintf("            ");
		     gotoxy(XWIN+4,YWIN+5+xt);
		     cprintf("%c\n",x+xt+'A');
		     gotoxy(XWIN+9,YWIN+5+xt);
		     switch(liste_drive[xt+x]->nature)
		     {
		      case FICTIF : cprintf("Fictif \n"); break;
		      case NORMAL : cprintf("Normal \n"); break;
		      case NETWORK: cprintf("Network\n"); break;
		      case RAMDISK: cprintf("Ramdisk\n"); break;
		     }
		     return 3;

      case FL_GAUCHE:textbackground(BLUE); textcolor(LIGHTGRAY);
		     gotoxy(XWIN+4,YWIN+5+xt);
		     cprintf("            ");
		     gotoxy(XWIN+4,YWIN+5+xt);
		     cprintf("%c\n",x+xt+'A');
		     gotoxy(XWIN+9,YWIN+5+xt);
		     switch(liste_drive[xt+x]->nature)
		     {
		      case FICTIF : cprintf("Fictif \n"); break;
		      case NORMAL : cprintf("Normal \n"); break;
		      case NETWORK: cprintf("Network\n"); break;
		      case RAMDISK: cprintf("Ramdisk\n"); break;
		     }
		     return 1;

      case DEBUT:    x = 0; xt=0; break;

      case PGUP:     x -=2; if (x <= 0) {x = 0; }
		     break;

      case FL_HAUT :
		     xt-=1;
		     if(xt<=-1)
		     {
		      xt= 0;
		      x -=1;
		      if (x <= 0)
		       {
			x = 0;
			xt= 0;
		       }
		     }
		     break;

      case FL_BAS  :
		     xt+=1;
		     if (maxdrive-1 >= 2)
		     {
		      if(xt >= 2)
		       {
			xt=1;
			x+=1;
			if(x+1 >= maxdrive-1)
			 {
			  x = maxdrive-1;
			  xt= 1;
			 }
		       }
		     }
		     else
		     {
		      if(xt >= maxdrive)
		       {
			xt=maxdrive;
		       }
		     }
		     break;

      case PGDN:     x +=2; if (maxdrive >=2)
		     {if (x >= maxdrive-1) {x = maxdrive-1;} }
		     else {x -=2;}
		     break;

      case FIN:      if (maxdrive >= 2)
		      {
		       x = maxdrive-1;
		       xt=1;
		      }
		     else
		      {
		       xt=maxdrive;
		      }
		     break;
    }
  }
}

/*
----------------------------------------------------
  Fonction : AFFICHE_REP
----------------------------------------------------
*/
int affiche_rep()
{
  unsigned int touche;
  int x = 0;
  int xt = 0;
  int tampaff;
  int bou;

  for(;;)
  { if (nbrepertoires >= 6) {tampaff = 6;}
    else {tampaff = nbrepertoires;}
    for(bou=0;bou <= tampaff;bou++)
    {
      textbackground(BLUE); textcolor(LIGHTGRAY);
      gotoxy(XWIN+4,YWIN+10+bou);
      cprintf("            ");
      gotoxy(XWIN+4,YWIN+10+bou);
      cprintf("%s\n",liste_rep[x+bou]);
      textbackground(GREEN); textcolor(WHITE);
      gotoxy(XWIN+4,YWIN+10+xt);
      cprintf("            ");
      gotoxy(XWIN+4,YWIN+10+xt);
      cprintf("%s\n",liste_rep[x+xt]);
    }
    touche=bioskey(0);
    fflush(stdin);
  switch(touche)
    {
      case ENTER:    textbackground(BLUE); textcolor(LIGHTGRAY);
		     gotoxy(XWIN+4,YWIN+10+xt);
		     cprintf("            ");
		     gotoxy(XWIN+4,YWIN+10+xt);
		     cprintf("%s\n",liste_rep[x+xt]);
		     chdir(liste_rep[x+xt]);
		     masque_saisie();
		     return 3;

      case ESC:      return 10;

      case TAB:      textbackground(BLUE); textcolor(LIGHTGRAY);
		     gotoxy(XWIN+4,YWIN+10+xt);
		     cprintf("            ");
		     gotoxy(XWIN+4,YWIN+10+xt);
		     cprintf("%s\n",liste_rep[x+xt]);
		     return 4;

      case FL_DROITE:textbackground(BLUE); textcolor(LIGHTGRAY);
		     gotoxy(XWIN+4,YWIN+10+xt);
		     cprintf("            ");
		     gotoxy(XWIN+4,YWIN+10+xt);
		     cprintf("%s\n",liste_rep[x+xt]);
		     return 4;

      case FL_GAUCHE:textbackground(BLUE); textcolor(LIGHTGRAY);
		     gotoxy(XWIN+4,YWIN+10+xt);
		     cprintf("            ");
		     gotoxy(XWIN+4,YWIN+10+xt);
		     cprintf("%s\n",liste_rep[x+xt]);
		     return 2;

      case DEBUT:    x = 0; xt=0; break;

      case PGUP:     x -=6; if (x <= 0) {x = 0; }
		     break;

      case FL_HAUT :
		     xt-=1;
		     if(xt<=0)
		     {
		      xt=0;
		      x -=1;
		      if (x <= 0)
		       {
			x = 0;
			xt= 0;
		       }
		     }
		     break;

      case FL_BAS  :
		     xt+=1;
		     if (nbrepertoires >= 6)
		     {
		      if(xt >= 6)
		       {
			xt=5;
			x+=1;
			if(x+5 >= nbrepertoires)
			 {
			  x = nbrepertoires-5;
			  xt= 5;
			 }
		       }
		     }
		     else
		     {
		      if(xt >= nbrepertoires)
		       {
			xt=nbrepertoires;
		       }
		     }
		     break;

      case PGDN:     x +=6; if (nbrepertoires >=6)
		     {if (x >= nbrepertoires-5) {x = nbrepertoires-5;} }
		     else {x -=6;}
		     break;

      case FIN:      if (nbrepertoires >= 6)
		      {
		       x = nbrepertoires-5;
		       xt=5;
		      }
		     else
		      {
		       xt=nbrepertoires;
		      }
		     break;
    }
  }
}

/*
----------------------------------------------------
  Fonction : AFFICHE_FICH
----------------------------------------------------
*/
int affiche_fich()
{
  unsigned int touche;
  int x = 0;
  int xt= 0;
  int tampaff;
  int bou;
  byte clavier;
  byte ascii;

  for(;;)
  { if (nbfichiers >= 11)
    {
     tampaff = 11;
    }
    else
    {
     tampaff = nbfichiers;
    }
    for(bou=0;bou <= tampaff;bou++)
    {
      textbackground(BLUE); textcolor(LIGHTGRAY);
      gotoxy(XWIN+20,YWIN+5+bou);
      cprintf("            ");
      gotoxy(XWIN+20,YWIN+5+bou);
      cprintf("%s\n",liste_fich[x+bou]);
      textbackground(GREEN); textcolor(WHITE);
      gotoxy(XWIN+20,YWIN+5+xt);
      cprintf("            ");
      gotoxy(XWIN+20,YWIN+5+xt);
      cprintf("%s\n",liste_fich[x+xt]);
    }
    touche=bioskey(0);
    fflush(stdin);
    switch(touche)
    {
      case ENTER:    textbackground(BLUE); textcolor(LIGHTGRAY);
		     gotoxy(XWIN+20,YWIN+5+xt);
		     cprintf("            ");
		     gotoxy(XWIN+20,YWIN+5+xt);
		     cprintf("%s\n",liste_fich[x+xt]);
		     strcpy(nom_fichier,liste_fich[x+xt]);
		     return 1;

      case ESC:      return 10;

      case TAB:      textbackground(BLUE); textcolor(LIGHTGRAY);
		     gotoxy(XWIN+20,YWIN+5+xt);
		     cprintf("            ");
		     gotoxy(XWIN+20,YWIN+5+xt);
		     cprintf("%s\n",liste_fich[x+xt]);
		     return 1;

      case FL_DROITE:textbackground(BLUE); textcolor(LIGHTGRAY);
		     gotoxy(XWIN+20,YWIN+5+xt);
		     cprintf("            ");
		     gotoxy(XWIN+20,YWIN+5+xt);
		     cprintf("%s\n",liste_fich[x+xt]);
		     return 1;

      case FL_GAUCHE:textbackground(BLUE); textcolor(LIGHTGRAY);
		     gotoxy(XWIN+20,YWIN+5+xt);
		     cprintf("            ");
		     gotoxy(XWIN+20,YWIN+5+xt);
		     cprintf("%s\n",liste_fich[x+xt]);
		     return 3;

      case DEBUT:    x = 0; xt=0; break;

      case PGUP:     x -=12;
		     if (x <= 0)
		     {
		      x = 0;
		     }
		     break;

      case FL_HAUT :
		     xt-=1;
		     if(xt<=0)
		     {
		      xt=0;
		      x -=1;
		      if (x <= 0)
		       {
			x = 0;
			xt= 0;
		       }
		     }
		     break;

      case FL_BAS  :
		     xt+=1;
		     if (nbfichiers >= 12)
		     {
		      if(xt >= 12)
		       {
			xt=11;
			x+=1;
			if(x+11 >= nbfichiers)
			 {
			  x = nbfichiers-11;
			  xt= 11;
			 }
		       }
		     }
		     else
		     {
		      if(xt >= nbfichiers)
		       {
			xt=nbfichiers;
		       }
		     }
		     break;

      case PGDN:     x +=12; if (nbfichiers >=12)
		     {
		      if (x >= nbfichiers-11)
		       {
			x = nbfichiers-11;
		       }
		     }
		     else
		     {
		      x -=12;
		     }
		     break;

      case FIN:      if (nbfichiers >= 12)
		      {
		       x = nbfichiers-11;
		       xt=11;
		      }
		     else
		      {
		       xt=nbfichiers;
		      }
		     break;
    }
  }
}

/*
----------------------------------------------------
  Fonction : NOM_PROG
----------------------------------------------------
*/
int nom_prog()
{
 byte clavier;
 byte ascii;

  _setcursortype(_NORMALCURSOR);
  strcpy(nom_fichier,getstr(XWIN+4,YWIN+2,20,20,TOUTCAR,
		LIGHTGRAY,BLUE,nom_fichier,&clavier,&ascii));
  _setcursortype(_NOCURSOR);
  switch (clavier)
   {
       case 0 :  switch (ascii)
		 {
		 }
		 break;

       case 9 :  strcpy(nom_fichier,"");
		 dputs(XWIN+4,YWIN+2,LIGHTGRAY,"            ");
		 gotoxy(XWIN+4,YWIN+2);
		 cprintf("%s",nom_fichier);
		 return 2;

       case 27 : strcpy(nom_fichier,"");
		 gotoxy(XWIN+4,YWIN+2); cprintf("%s",nom_fichier);
		 return 10;
   }
  gotoxy(XWIN+4,YWIN+2); cprintf("%s",nom_fichier);
  return 10;
}


/*
----------------------------------------------------
  Fonction : LECTURE_FICHIER
----------------------------------------------------
*/
char *lecture_fichier()
{
  int x=1;
  byte clavier;
  byte ascii;
  struct windowdef *window1;
  s_mouse s_etat_souris;

 mousecurtxt(FALSE,0x00FF,0x4E00);
 mouseshow();
 mousegotoxy(1,1);

   _setcursortype(_NOCURSOR);

  window1 = openwindow(XWIN, YWIN, XWIN+35, YWIN+23, FRAMEBORDER,
    Attr(BLUE,LIGHTGRAY), Attr(BLACK,LIGHTGRAY), FALSE, "");

 masque_saisie();

 while(x!=10)
 {
  s_etat_souris=mousestatus();
  switch(x)
  {
   case 1:  x=nom_prog();
	    break;

   case 2:  x=3; /* x=affiche_lect(); */
	    break;

   case 3:  x=affiche_rep();
	    break;

   case 4:  x=affiche_fich();
	    break;
  }
 }

     /* nettoyage de la mmoire */

   freelstchar(nbfichiers,    liste_fich);
   freelstchar(nbrepertoires, liste_rep);
   freelstsdrive(maxdrive,    liste_drive);

   closewindow(window1);
   textbackground(BLACK); textcolor(LIGHTGRAY);
   _setcursortype(_NORMALCURSOR);
   return nom_fichier;
}

/*
----------------------------------------------------
  Fonction : MAIN
----------------------------------------------------
*/
/*
void main(void)
{
 char nom_fich_2[15];

 gotoxy(1,4); cprintf("OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO");
 gotoxy(1,5); cprintf("OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO");
 gotoxy(1,6); cprintf("OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO");
 gotoxy(1,7); cprintf("OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO");
 gotoxy(1,8); cprintf("OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO");
 gotoxy(1,9); cprintf("OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO");

  strcpy(nom_fich_2,lecture_fichier());
  gotoxy(1,2);
  cprintf("%s",nom_fich_2);
  getch();

  clrscr();

}
*/