/*ͻ
     Nom du fichier : WMLIB.H                                             
  ͹
     Fonction       : Fichier en-tte pour les modules composants la      
                      bibliothque WMLIB.LIB                              
                                                                          
  Ķ
     Auteur         : William MARIE                                       
     Dvelopp le   : 12/10/91                                            
     Dernire modif.: 04/01/92                                            
  Ķ
     Compilation    :  inclure dans un programme                         
                                                                          
  ͼ*/

#ifndef _WMLIB_H   /* prvention des inclusions multiples */
#define _WMLIB_H

#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <dir.h>
#include <io.h>

  /*=========================== DEFINITIONS ==============================*/
#define word unsigned int
#define byte unsigned char

typedef enum {FALSE, TRUE} boolean;     /* le type boolen pour les habitus
                                           du pascal: FALSE = 0, TRUE = 1  */
  /*  Les dclarations ci-dessous sont quivalentes
typedef char boolean;
#define FALSE ((boolean)0)
#define TRUE  ((boolean)(!FALSE))
  */
typedef enum { FICTIF = -1, NORMAL = 0, NETWORK, RAMDISK } type_disk;
typedef struct
{
  byte      drive;
  type_disk nature;
} sdrive;
enum { TOUTCAR, NUMERIQUE, MAJUSCULE };
enum { TRI_SANS, TRI_NOM, TRI_DATE, TRI_TAILLE_D, TRI_TAILLE_C };
enum                /* types de cadres */
{
  NOBORDER      = -1,     /* pas de cadre */
  SPACEBORDER,            /* espace comme cadre */
  SINGLEBORDER,           /* encadrement 1 ligne */
  DOUBLEBORDER,           /* encadrement 2 lignes */
  BORDER176,              /* encadrement avec le caractre 176 */
  BORDER177,              /* encadrement avec le caractre 177 */
  BORDER178,              /* encadrement avec le caractre 178 */
  FRAMEBORDER,            /* encadrement en cadre */
  MAXBORDER,
};

  /*=========================== MACROS ===================================*/
#define xor(a,b) (((!a)&&(b)) || ((a)&&(!b)))
#define Attr(coultext, coulfond) ((coultext) | ((coulfond) << 4))
  /* couleur de fond: quartet de gauche, couleur de caractre: quartet
     de droite */
#define coultext(attribut) ((attribut) & (0x0F))
#define coulfond(attribut) (((attribut) & (0xF0)) >> 4)
struct dtime
{
  word dt_annee;
  word dt_mois;
  word dt_jour;
  word dt_heure;
  word dt_minute;
  word dt_seconde;
};

  /*====================== variables globales ============================*/
extern byte cur1, cur2;            /* valeurs du curseur d'origine           */
extern word videoseg;          /* initialis  0 pour contrle d'affectation */
extern boolean cursorsaved;        /* contrle de la sauvegarde du curseur   */
extern struct text_info info_text; /* structure de type text_info            */
extern byte videocard;             /* numro de la carte video               */
extern boolean colorcard;          /* TRUE = couleur, FALSE = mono           */
extern char *video_device[];      /* chane de dsignation carte et moniteur */
extern const char *nom_jour[];     /* tableau des noms franais des jours */
extern byte maxdrive;              /* nombre des lecteurs logiques du DOS */

  /*============================= prototypes =============================*/
#ifdef __cplusplus
extern "C" {
#endif

char             *convbin16(unsigned int nombre);
unsigned long     conv2int(unsigned __fort, unsigned __faible);
int               ctrldate(char *chaine_date, word *jour, word *mois,
                    word *annee);
void              dputch(byte __x, byte __y, byte __coultext, char __car);
void              dputs(byte __x, byte __y, byte __coultext, char *__str);
void              drelin(void);
struct ftime      dtimetoftime(struct dtime *ptr_dtime);
unsigned long     dtimetolft(struct dtime *_dt);
void              errexit(byte __i);
void              frame(byte __X1, byte __Y1, byte __X2, byte __Y2,
                    byte __type_cadre, byte __coul_car, byte __coul_fond,
                    boolean __ombrage, boolean __efface);
void              freelstchar(int __total, char **__liste);
void              freelstffblk(int total, struct ffblk **liste);
void              freelstsdrive(byte __total, sdrive **__liste);
struct dtime      ftimetodtime(struct ftime *ptr_ftime);
struct dtime      getdtimesys(void);
void             *getmem(int size);
char             *getstr( byte x, byte y, word LongTotale, word LongSaisie,
                    byte SaisieAttr, byte CoulTxt, byte CoulFond,
                    char *EntreeChaine, byte *carclav, byte *codclav );
char             *getstrdatesys(void);
char             *getstrtimesys(void);
void              hidecursor(void);
long              lround(long a, long b);
struct ffblk    **mklstffblk(char *masque, char attribut, int *nombre,
                    int tri);
char            **mklstfile (char *__masque, char __attribut, int *__nombre);
sdrive          **mklstsdrive(void);
void              printcenter(char *text, byte line, byte color);
void              readcursor(void);
void              repchar(byte N, char C);
int               round(int a, int b);
void              selectcolor(int x, int y, byte *coultext, byte *coulfond);
void              showcursor(void);
void              squarecursor(void);
char             *strdtime(struct dtime *_dt);
unsigned char     toupperfr (unsigned char c);
void              wmlibinit(void);

#ifdef __cplusplus
}
#endif
#endif /* WMLIB_H */